
{*******************************************************}
{                                                       }
{       MiTeC System Information Component              }
{           version 4.1 for Delphi 3,4,5                }
{                                                       }
{       Copyright (C) 1997,2000 MichaL MutL             }
{                                                       }
{*******************************************************}

{$IFDEF VER130}
  {$DEFINE D4PLUS}
{$ENDIF}
{$IFDEF VER120}
  {$DEFINE D4PLUS}
{$ENDIF}

{$UNDEF ONLYWIN9X}
{ Define this flag only if you want to use this component in programs running
  under Win9x platform }

unit MSystemInfo;

interface

uses
  SysUtils, Windows, Classes,Registry, MMSystem, WinSock, Printers, DsgnIntf;

const
  cAbout = 'MiTeC System Info 4.1 - Copyright  1997-2000 MichaL MutL';

  cSystem = 0;
  cGDI = 1;
  cUSER = 2;

  NBNAMESIZE    = 16;
  MAXLANAS      = 254;
  NCB_ASYNC     = $80;   { asynch command bit to be or-ed into command }
  NCB_CALL      = $10;   { open a session }
  NCB_LISTEN    = $11;   { wait for a call }
  NCB_HANGUP    = $12;   { end session }
  NCB_SEND      = $14;   { send data }
  NCB_RECV      = $15;   { receive data }
  NCB_RECVANY   = $16;   { receive data on any session }
  NCB_CHAINSEND = $17;   { chain send data }
  NCB_DGSEND    = $20;   { send a datagram }
  NCB_DGRECV    = $21;   { receive datagram }
  NCB_DGSENDBC  = $22;   { send broadcast datagram }
  NCB_DGREVCBC  = $23;   { receive broadcast datagram }
  NCB_ADDNAME   = $30;   { add unique name to local table }
  NCB_DELNAME   = $31;   { delete name from local table }
  NCB_RESET     = $32;   { reset adapter }
  NCB_ADPSTAT   = $33;   { adapter status }
  NCB_SSTAT     = $34;   { session status }
  NCB_CANCEL    = $35;   { cancel NCB request }
  NCB_ADDGRPNAME= $36;   { add group name to local table }
  NCB_ENUM      = $37;   { enum adapters }
  NCB_UNLINK    = $70;   { unlink remote boot code }
  NCB_SENDNA    = $71;   { send, don't wait for ACK }
  NCB_CHAINSENDNA=$72;   { chain send, but don't wait for ACK }
  NCB_LANSTALERT= $73;   { lan status alert }
  NCB_ACTION    = $77;   { enable extensions }
  NCB_FINDNAME  = $78;   { search for name on the network }
  NCB_TRACE     = $79;   { activate / stop tracing }
  NRC_GOODRET     = $00;    { good return
  NRC_BUFLEN      = $01;    { illegal buffer length                      }
  NRC_ILLCMD      = $03;    { illegal command                            }
  NRC_CMDTMO      = $05;    { command timed out                          }
  NRC_INCOMP      = $06;    { message incomplete, issue another command  }
  NRC_BADDR       = $07;    { illegal buffer address                     }
  NRC_SNUMOUT     = $08;    { session number out of range                }
  NRC_NORES       = $09;    { no resource available                      }
  NRC_SCLOSED     = $0a;    { session closed                             }
  NRC_CMDCAN      = $0b;    { command cancelled                          }
  NRC_DUPNAME     = $0d;    { duplicate name                             }
  NRC_NAMTFUL     = $0e;    { name table full                            }
  NRC_ACTSES      = $0f;    { no deletions, name has active sessions     }
  NRC_LOCTFUL     = $11;    { local session table full                   }
  NRC_REMTFUL     = $12;    { remote session table full                  }
  NRC_ILLNN       = $13;    { illegal name number                        }
  NRC_NOCALL      = $14;    { no callname                                }
  NRC_NOWILD      = $15;    { cannot put * in NCB_NAME                   }
  NRC_INUSE       = $16;    { name in use on remote adapter              }
  NRC_NAMERR      = $17;    { name deleted                               }
  NRC_SABORT      = $18;    { session ended abnormally                   }
  NRC_NAMCONF     = $19;    { name conflict detected                     }
  NRC_IFBUSY      = $21;    { interface busy, IRET before retrying       }
  NRC_TOOMANY     = $22;    { too many commands outstanding, retry later }
  NRC_BRIDGE      = $23;    { ncb_lana_num field invalid                 }
  NRC_CANOCCR     = $24;    { command completed while cancel occurring   }
  NRC_CANCEL      = $26;    { command not valid to cancel                }
  NRC_DUPENV      = $30;    { name defined by anther local process       }
  NRC_ENVNOTDEF   = $34;    { environment undefined. RESET required      }
  NRC_OSRESNOTAV  = $35;    { required OS resources exhausted            }
  NRC_MAXAPPS     = $36;    { max number of applications exceeded        }
  NRC_NOSAPS      = $37;    { no saps available for netbios              }
  NRC_NORESOURCES = $38;    { requested resources are not available      }
  NRC_INVADDRESS  = $39;    { invalid ncb address or length > segment    }
  NRC_INVDDID     = $3B;    { invalid NCB DDID                           }
  NRC_LOCKFAIL    = $3C;    { lock of user area failed                   }
  NRC_OPENERR     = $3f;    { NETBIOS not loaded                         }
  NRC_SYSTEM      = $40;    { system error                               }
  NRC_PENDING     = $ff;    { asynchronous command is not yet finished   }
  ALL_TRANSPORTS = 'M'#$00#$00#$00;
  MS_NBF         = 'MNBF';
  NAME_FLAGS_MASK = $87;
  GROUP_NAME      = $80;
  UNIQUE_NAME     = $00;

  FILE_SUPPORTS_ENCRYPTION = 32;
  FILE_SUPPORTS_OBJECT_IDS = 64;
  FILE_SUPPORTS_REPARSE_POINTS = 128;
  FILE_SUPPORTS_SPARSE_FILES = 256;
  FILE_VOLUME_QUOTAS = 512;

type
  {$IFDEF D4PLUS}
     TLargInt = _LARGE_INTEGER;
  {$ELSE}
     TLargInt = TLargeInteger;
     Int64 = TLargeInteger;
     LongWord = DWORD;
  {$ENDIF}

  TStrBuf = array[0..11] of char;

  TPlatFormType = (os9x,osNT4,os2K);

  { Netbios Name }
  TNBName = array[0..(NBNAMESIZE - 1)] of byte;

 { MAC address }
  TMacAddress = array[0..5] of byte;

  PNCB = ^TNCB;

 { Netbios Control Block }

 {$IFDEF WIN32}
  TNCBPostProc = procedure(P: PNCB);
 {$ENDIF}

  TNCB = packed record        { Netbios Control Block }
    Command:  byte;      { command code                       }
    RetCode:  byte;      { return code                        }
    LSN:      byte;      { local session number               }
    Num:      byte;      { name number                        }
    Buf:      ^byte;     { data buffer                        }
    Length:   word;      { data length                        }
    CallName: TNBName;   { name to call                       }
    Name:     TNBName;   { our own name                       }
    RTO:      byte;      { receive time-out                   }
    STO:      byte;      { send time-out                      }
  {$IFNDEF WIN32}
    Post_Offs:word;      { asynch notification routine offset }
    Post_Seg: word;      { asynch notification routine segment}
  {$ELSE}
    PostPrc:  TNCBPostProc;{ asynch notification routine (nb30) }
  {$ENDIF}
    Lana_Num: byte;     { adapter number                     }
    Cmd_Cplt: byte;     { command completion flag            }
  {$IFDEF WIN32}
    Reserved: array[0..9] of byte;  { Reserverd for Bios use }
    Event:    THandle;  { WIN32 event handle to be signalled }
                        { for asynch cmd completion          }
  {$ELSE}
    Reserved: array[0..13] of byte;  { Reserved }
  {$ENDIF}
  end;


{ Netbios Name Info record }
  PNameInfo = ^TNameInfo;
  TNameInfo = packed record  { name info record }
    Name:   TNBName;       { netbios name }
    NameNum:byte;          { name number  }
    NameSt: byte;          { name status  }
  end;

{ Netbios adapter status }
  PAdpStat = ^TAdpStat;
  TAdpStat = packed record    { adapter status record}
    ID:       TMacAddress;   { adapter mac address           }
    VMajor:   byte;          { software version major number }
    Resvd0:   byte;
    AdpType:  byte;          { adapter type                  }
    VMinor:   byte;          { software version minor number }
    RptTime:  word;          { reporting time period         }
    RcvCRC:   word;          { receive crc errors            }
    RcvOth:   word;          { receive other errors          }
    TxmCol:   word;          { transmit collisions           }
    TxmOth:   word;          { transmit other errors         }
    TxmOK:    LongInt;       { successfull transmissions     }
    RcvOK:    LongInt;       { successfull receives          }
    TxmRetr:  word;          { transmit retries              }
    NoRcvBuf: word;          { number of 'no receive buffer' }
    T1_tmo:   word;          { t1 time-outs                  }
    Ti_tmo:   word;          { ti time_outs                  }
    Resvd1:   LongInt;
    Free_Ncbs:word;          { number of free ncb's          }
    Cfg_Ncbs: word;          { number of configured ncb's    }
    max_Ncbs: word;          { max ncb's used                }
    NoTxmBuf: word;          { number of 'no transmit buffer'}
    MaxDGSize:word;          { max. datagram size            }
    Pend_Ses: word;          { number of pending sessions    }
    Cfg_Ses:  word;          { number of configured sessions }
    Max_Ses:  word;          { max sessions used             }
    Max_SPSz: word;          { max. session packet size      }
    nNames:   word;          { number of names in local table}
    Names:    array[0..15] of TnameInfo; { local name table  }
  end;

{
   Structure returned to the NCB command NCBSSTAT is SESSION_HEADER followed
   by an array of SESSION_BUFFER structures. If the NCB_NAME starts with an
   asterisk then an array of these structures is returned containing the
   status for all names.
}

{ session header }
  PSession_Header = ^TSession_Header;
  TSession_Header = packed record
    sess_name:            byte;
    num_sess:             byte;
    rcv_dg_outstanding:   byte;
    rcv_any_outstanding:  byte;
  end;

{ session buffer }
  PSession_Buffer = ^TSession_Buffer;
  TSession_Buffer = packed record
    lsn:                  byte;
    state:                byte;
    local_name:           TNBName;
    remote_name:          TNBName;
    rcvs_outstanding:     byte;
    sends_outstanding:    byte;
  end;

{
   Structure returned to the NCB command NCBENUM.

   On a system containing lana's 0, 2 and 3, a structure with
   length =3, lana[0]=0, lana[1]=2 and lana[2]=3 will be returned.
}
  PLana_Enum = ^TLana_Enum;
  TLANA_ENUM = packed record
    length:   byte;         {  Number of valid entries in lana[] }
    lana:     array[0..(MAXLANAS - 1)] of byte;
  end;

{
   Structure returned to the NCB command NCBFINDNAME is FIND_NAME_HEADER followed
   by an array of FIND_NAME_BUFFER structures.
 }

  PFind_Name_Header = ^TFind_Name_Header;
  TFind_Name_Header = packed record
    node_count:    word;
    reserved:      byte;
    unique_group:  byte;
  end;

  PFind_Name_Buffer = ^TFind_Name_Buffer;
  TFind_Name_Buffer = packed record
    length:          byte;
    access_control:  byte;
    frame_control:   byte;
    destination_addr:TMacAddress;
    source_addr:     TMacAddress;
    routing_info:    array[0..17] of byte;
  end;

{
   Structure provided with NCBACTION. The purpose of NCBACTION is to provide
   transport specific extensions to netbios.
 }

  PAction_Header = ^TAction_Header;
  TAction_Header = packed record
    transport_id: LongInt;
    action_code:  Word;
    reserved:     Word;
  end;

  TCPUFeatures = class(TPersistent)
  private
    FSYSENTERExt: boolean;
    FMTRR: boolean;
    FModSpecReg: boolean;
    FPageSizeExt: boolean;
    FTimeStampCnt: boolean;
    FMachineChkExc: boolean;
    FMMX: boolean;
    FPageAttrTable: boolean;
    FPhysAddrExt: boolean;
    FFXInstr: boolean;
    FVirtModExt: boolean;
    FPageGlobalExt: boolean;
    FCMOVccOpcode: boolean;
    FFPU: boolean;
    FCMPXCHG8B: boolean;
    FMachineCheck: boolean;
    FAPIC: boolean;
    FDebugExt: boolean;
    FPageSizeExt36bit: boolean;
  public
    procedure GetFeaturesStr(AClear :boolean; AFeatures :TStringList);
  published
    property FXInstr :Boolean read FFXInstr write FFxInstr stored false;
    property MMX :Boolean read FMMX write FMMX stored false;
    property PageSizeExt36bit :Boolean read FPageSizeExt36bit write FPageSizeExt36bit stored false;
    property PageAttrTable :Boolean read FPageAttrTable write FPageAttrTable stored false;
    property CMOVccOpcode :Boolean read FCMOVccOpcode write FCMOVccOpcode stored false;
    property MachineCheck :Boolean read FMachineCheck write FMachineCheck stored false;
    property PageGloablExt :Boolean read FPageGlobalExt write FPageGlobalExt stored false;
    property MTRR :Boolean read FMTRR write FMTRR stored false;
    property SYSENTERExt :Boolean read FSYSENTERExt write FSYSENTERExt stored false;
    property APIC :Boolean read FAPIC write FAPIC stored false;
    property CMPXCHG8B :Boolean read FCMPXCHG8B write FCMPXCHG8B stored false;
    property MachineChkExc :Boolean read FMachineChkExc write FMachineChkExc stored false;
    property PhysAddrExt :Boolean read FPhysAddrExt write FPhysAddrExt stored false;
    property ModSpecReg :Boolean read FModSpecReg write FModSpecReg stored false;
    property TimeStampCnt :Boolean read FTimeStampCnt write FTimeStampCnt stored false;
    property PageSizeExt :Boolean read FPageSizeExt write FPageSizeExt stored false;
    property DebugExt :Boolean read FDebugExt write FDebugExt stored false;
    property VirtModExt :Boolean read FVirtModExt write FVirtModExt stored false;
    property FPU :Boolean read FFPU write FFPU stored false;
  end;

  TCPU = class(TPersistent)
  private
    FVendorID,
    FVendor,
    FSubModel: string;
    FModel,
    FCount,
    FArchitecture,
    FLevel,
    FStepping,
    FFamily,
    FTyp,
    FVendorNo,
    FFreq :integer;
    FCPUID :boolean;
    FFeatures: TCPUFeatures;
    function CPUIDExists: boolean;
    procedure GetCPUID;
    function GetCPUIDLevel :integer;
    function GetCPUType :integer;
    function GetCPUVendor :string;
    function GetCPUVendorID :string;
    function GetCPUFreqEx :extended;
    function GetSubModel :string;
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property CPUID :Boolean read FCPUID write FCPUID stored false;
    property Architecture :integer read FArchitecture write FArchitecture stored false;
    property Level :integer read FLevel write FLevel stored false;
    property Count :integer read FCount write FCount stored false;
    property Vendor :string read FVendor write FVendor stored false;
    property VendorID :string read FVendorID write FVendorID stored false;
    property Freq :integer read FFreq write FFreq stored false;
    property Family :integer read FFamily write FFamily stored false;
    property Stepping :integer read FStepping write FStepping stored false;
    property Model :integer read FModel write FModel stored false;
    property Typ :integer read FTyp write FTyp stored false;
    property Features :TCPUFeatures read FFeatures write FFeatures;
    property SubModel :string read FSubModel write FSubModel stored false;
  end;

  TMemory = class(TPersistent)
  private
    FMaxAppAddress: integer;
    FVirtualTotal: integer;
    FPageFileFree: integer;
    FVirtualFree: integer;
    FPhysicalFree: integer;
    FAllocGranularity: integer;
    FMinAppAddress: integer;
    FMemoryLoad: integer;
    FPhysicalTotal: integer;
    FPageFileTotal: integer;
    FPageSize: integer;
    FGDIRes: Byte;
    FUserRes: Byte;
    FSystemRes: Byte;

    function GetSystemRes: Byte;
    function GetGDIRes: Byte;
    function GetUSERRes: Byte;
  public
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property PhysicalTotal :integer read FPhysicalTotal write FPhysicalTotal stored false;
    property PhysicalFree :integer read FPhysicalFree write FPhysicalFree stored false;
    property VirtualTotal :integer read FVirtualTotal write FVirtualTotal stored false;
    property VirtualFree :integer read FVirtualFree write FVirtualFree stored false;
    property PageFileTotal :integer read FPageFileTotal write FPageFileTotal stored false;
    property PageFileFree :integer read FPageFileFree write FPageFileFree stored false;
    property MemoryLoad :integer read FMemoryLoad write FMemoryLoad stored false;
    property AllocGranularity :integer read FAllocGranularity write FAllocGranularity stored false;
    property MaxAppAddress :integer read FMaxAppAddress write FMaxAppAddress stored false;
    property MinAppAddress :integer read FMinAppAddress write FMinAppAddress stored false;
    property PageSize :integer read FPageSize write FPageSize stored false;
    property Win9x_SystemRes: Byte read FSystemRes write FSystemRes stored false;
    property Win9x_GDIRes: Byte read FGDIRes write FGDIRes stored false;
    property Win9x_UserRes: Byte read FUserRes write FUserRes stored false;
  end;

  PWindow = ^TWindow;
  TWindow = record
    ClassName,
    Text :string;
    Handle,
    Process,
    Thread :longword;
    ParentWin,
    WndProc,
    Instance,
    ID,
    UserData,
    Style,
    ExStyle :longint;
    Rect,
    ClientRect :TRect;
    Atom,
    ClassBytes,
    WinBytes,
    ClassWndProc,
    ClassInstance,
    Background,
    Cursor,
    Icon,
    ClassStyle :longword;
    Styles,
    ExStyles,
    ClassStyles :tstringlist;
    Visible :boolean;
  end;

  TTimeZone = class(TPersistent)
  private
    FStdBias: integer;
    FDayBias: integer;
    FBias: integer;
    FDisp: string;
    FStd: string;
    FDayStart: TDatetime;
    FStdStart: TDatetime;
    FDay: string;
    FMap: string;
  public
    procedure GetInfo;
    procedure Report(var sl :TStringList);
    property MapID: string read FMap;
  published
    property DisplayName: string read FDisp write FDisp stored False;
    property StandardName: string read FStd write FStd stored False;
    property DaylightName: string read FDay write FDay stored False;
    property DaylightStart: TDatetime read FDayStart write FDayStart stored False;
    property StandardStart: TDatetime read FStdStart write FStdStart stored False;
    property Bias: integer read FBias write FBias stored False;
    property DaylightBias: integer read FDayBias write FDayBias stored False;
    property StandardBias: integer read FStdBias write FStdBias stored False;
  end;

  TOperatingSystem = class(TPersistent)
  private
    FBuildNumber: integer;
    FMajorVersion: integer;
    FMinorVersion: integer;
    FPlatform: string;
    FCSD: string;
    FVersion: string;
    FRegUser: string;
    FSerialNumber: string;
    FRegOrg: string;
    FEnv: TStrings;
    FDirs: TStrings;
    FTZ: TTimeZone;

    procedure GetEnvironment;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property MajorVersion :integer read FMajorVersion write FMajorVersion stored false;
    property MinorVersion :integer read FMinorVersion write FMinorVersion stored false;
    property BuildNumber :integer read FBuildNumber write FBuildNumber stored false;
    property Platform :string read FPlatform write FPlatform stored false;
    property Version :string read FVersion write FVersion stored false;
    property CSD :string read FCSD write FCSD stored false;
    property SerialNumber :string read FSerialNumber write FSerialNumber stored false;
    property RegisteredUser :string read FRegUser write FRegUser stored false;
    property RegisteredOrg :string read FRegOrg write FRegOrg stored false;
    property TimeZone :TTimeZone read FTZ write FTZ stored false;
    property Environment :TStrings read FEnv write FEnv stored false;
    property Directories: TStrings read FDirs write FDirs stored False;
  end;

  TFileFlag = (fsCaseIsPreserved, fsCaseSensitive, fsUnicodeStoredOnDisk,
               fsPersistentAcls, fsFileCompression, fsVolumeIsCompressed,
               fsLongFileNames,
               // following flags are valid only for Windows2000
               fsEncryptedFileSystemSupport, fsObjectIDsSupport, fsReparsePointsSupport,
               fsSparseFilesSupport, fsDiskQuotasSupport);
  TFileFlags = set of TFileFlag;

  TDriveType = (dtUnknown, dtNotExists, dtRemovable, dtFixed, dtRemote, dtCDROM, dtRAMDisk);

  TDiskSign = string[2];

  TDisk = class(TPersistent)
  private
    FDisk: TDiskSign;
    FMediaPresent: Boolean;
    FDriveType: TDriveType;
    FSectorsPerCluster: DWORD;
    FBytesPerSector: DWORD;
    FFreeClusters: DWORD;
    FTotalClusters: DWORD;
    FFileFlags: TFileFlags;
    FVolumeLabel: string;
    FSerialNumber: string;
    FFileSystem: string;
    FFreeSpace: int64;
    FCapacity: int64;
    FAvailDisks: string;
    FSerial: dword;
    FModel: string;
    FFDC: TStrings;
    FCDC: TStrings;
    FHDC: TStrings;
    function GetMediaPresent: Boolean;
  protected
    procedure SetDisk(const Value: TDiskSign);
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetInfo;
    function GetDriveTypeStr(dt :TDriveType) :string;
    procedure GetFileFlagsStr(AClear :boolean; var AFileFlags :TStringList);
    procedure Report(var sl :TStringList);
    function GetCD :byte;
    property Serial :dword read FSerial write FSerial stored false;
  published
    property Drive :TDiskSign read FDisk write SetDisk stored false;
    property AvailableDisks :string read FAvailDisks write FAvailDisks stored false;
    property MediaPresent :Boolean read GetMediaPresent write FMediaPresent stored false;
    property DriveType :TDriveType read FDriveType write FDriveType stored false;
    property FileFlags :TFileFlags read FFileFlags write FFileFlags stored false;
    property FileSystem :string read FFileSystem write FFileSystem stored false;
    property FreeClusters :DWORD read FFreeClusters write FFreeClusters stored false;
    property TotalClusters :DWORD read FTotalClusters write FTotalClusters stored false;
    // FreeSpace and Capacity returns good results for Win95 OSR2, Win98, NT and 2000
    // for Win95 there can be bad sizes for drives over 2GB
    property FreeSpace :int64 read FFreeSpace write FFreeSpace stored false;
    property Capacity :int64 read FCapacity write FCapacity stored false;
    property SerialNumber :string read FSerialNumber write FSerialNumber stored false;
    property VolumeLabel :string read FVolumeLabel write FVolumeLabel stored false;
    property SectorsPerCluster :DWORD read FSectorsPerCluster write FSectorsPerCluster stored false;
    property BytesPerSector :DWORD read FBytesPerSector write FBytesPerSector stored false;
    property Model: string read FModel write FModel stored False;

    property HDController: TStrings read FHDC write FHDC stored False;
    property FDController: TStrings read FFDC write FFDC stored False;
    property CDROMController: TStrings read FCDC write FCDC stored False;
  end;

  TWorkstation = class(TPersistent)
  private
    FName: string;
    FLastBoot: TDatetime;
    FUser: string;
    FSystemUpTime: Extended;
    FBIOSExtendedInfo: string;
    FBIOSCopyright: string;
    FBIOSName: string;
    FBIOSDate: string;
    FScrollLock: Boolean;
    FNumLock: Boolean;
    FCapsLock: Boolean;
    function GetSystemUpTime: Extended;
  public
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property Name :string read FName write FName stored false;
    property User :string read FUser write FUser stored false;
    property SystemUpTime :Extended read FSystemUpTime write FSystemUpTime stored false;
    property LastBoot :TDatetime read FLastBoot write FLastBoot stored false;
    property BIOSCopyright :string read FBIOSCopyright write FBIOSCopyright stored false;
    property BIOSDate :string read FBIOSDate write FBIOSDate stored false;
    property BIOSExtendedInfo :string read FBIOSExtendedInfo write FBIOSExtendedInfo stored false;
    property BIOSName :string read FBIOSName write FBIOSName stored false;
    property CapsLock: Boolean read FCapsLock write FCapsLock stored false;
    property NumLock: Boolean read FNumLock write FNumLock stored false;
    property ScrollLock: Boolean read FScrollLock write FScrollLock stored false;
  end;

  TWinsock = class(TPersistent)
  private
    FDesc: string;
    FStat: string;
    FMajVer: word;
    FMinVer: word;
  public
    procedure GetInfo;
  published
    property Description: string read FDesc write FDesc stored False;
    property MajorVersion: word read FMajVer write FMajVer stored False;
    property MinorVersion: word read FMinVer write FMinVer stored False;
    property Status: string read FStat write FStat stored False;
  end;

  TNetwork = class(TPersistent)
  private
    FAdapter: TStrings;
    FWinsock: TWinsock;
    FIPAddress: TStrings;
    FMACAddress: TStrings;
    FCli: TStrings;
    FServ: TStrings;
    FProto: TStrings;
    function GetLocalIP :string;
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property IPAddress: TStrings read FIPAddress write FIPAddress stored false;
    property MACAddress: TStrings read FMACAddress write FMACAddress stored False;
    property Adapter :TStrings read FAdapter write FAdapter stored false;
    property Protocol :TStrings read FProto write FProto stored False;
    property Service :TStrings read FServ write FServ stored False;
    property Client :TStrings read FCli write FCli stored False;
    property WinSock: TWinsock read FWinsock write FWinsock;
  end;

  TCurveCap = (ccCircles,ccPieWedges,ccChords,ccEllipses,ccWideBorders,ccStyledBorders,
               ccWideStyledBorders,ccInteriors,ccRoundedRects);
  TLineCap = (lcPolylines,lcMarkers,lcMultipleMarkers,lcWideLines,lcStyledLines,
               lcWideStyledLines,lcInteriors);
  TPolygonCap = (pcAltFillPolygons,pcRectangles,pcWindingFillPolygons,pcSingleScanlines,
                 pcWideBorders,pcStyledBorders,pcWideStyledBorders,pcInteriors);
  TRasterCap = (rcRequiresBanding,rcTranserBitmaps,rcBitmaps64K,rcSetGetDIBits,
                rcSetDIBitsToDevice,rcFloodfills,rcWindows2xFeatures,rcPaletteBased,
                rcScaling,rcStretchBlt,rcStretchDIBits);
  TTextCap = (tcCharOutPrec,tcStrokeOutPrec,tcStrokeClipPrec,tcCharRotation90,
              tcCharRotationAny,tcScaleIndependent,tcDoubledCharScaling,tcIntMultiScaling,
              tcAnyMultiExactScaling,tcDoubleWeightChars,tcItalics,tcUnderlines,
              tcStrikeouts,tcRasterFonts,tcVectorFonts,tcNoScrollUsingBlts);

  TCurveCaps = set of TCurveCap;
  TLineCaps = set of TLineCap;
  TPolygonCaps = set of TPolygonCap;
  TRasterCaps = set of TRasterCap;
  TTextCaps = set of TTextCap;

  TDisplay = class(TPersistent)
  private
    FVertRes: integer;
    FColorDepth: integer;
    FHorzRes: integer;
    FBIOSDate: string;
    FBIOSVersion: string;
    FPixelDiagonal: integer;
    FPixelHeight: integer;
    FVertSize: integer;
    FPixelWidth: integer;
    FHorzSize: integer;
    FTechnology: string;
    FCurveCaps: TCurveCaps;
    FLineCaps: TLineCaps;
    FPolygonCaps: TPolygonCaps;
    FRasterCaps: TRasterCaps;
    FTextCaps: TTextCaps;
    FMemory: TStrings;
    FChipset: TStrings;
    FAdapter: TStrings;
    FDAC: TStrings;
    FAcc: TStrings;
    FModes: TStrings;
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetInfo;
    procedure GetCurveCapsStr(AClear :boolean; ACaps :TStringList);
    procedure GetLineCapsStr(AClear :boolean; ACaps :TStringList);
    procedure GetPolygonCapsStr(AClear :boolean; ACaps :TStringList);
    procedure GetRasterCapsStr(AClear :boolean; ACaps :TStringList);
    procedure GetTextCapsStr(AClear :boolean; ACaps :TStringList);
    procedure Report(var sl :TStringList);
  published
    property Adapter :TStrings read FAdapter write FAdapter stored false;
    property Accelerator :TStrings read FAcc write FAcc stored false;
    property DAC :TStrings read FDAC write FDAC stored false;
    property Chipset :TStrings read FChipset write FChipset stored false;
    property Memory :TStrings read FMemory write FMemory stored false;
    property HorzRes :integer read FHorzRes write FHorzRes stored false;
    property VertRes :integer read FVertRes write FVertRes stored false;
    property ColorDepth :integer read FColorDepth write FColorDepth stored false;
    // BIOS info is available only under NT
    property BIOSVersion :string read FBIOSVersion write FBIOSVersion stored false;
    property BIOSDate :string read FBIOSDate write FBIOSDate stored false;
    property Technology :string read FTechnology write FTechnology stored false;
//    property HorzSize :integer read FHorzSize write FHorzSize stored false;
//    property VertSize :integer read FVertSize write FVertSize stored false;
    property PixelWidth :integer read FPixelWidth write FPixelWidth stored false;
    property PixelHeight :integer read FPixelHeight write FPixelHeight stored false;
    property PixelDiagonal :integer read FPixelDiagonal write FPixelDiagonal stored false;
    property RasterCaps :TRasterCaps read FRasterCaps write FRasterCaps stored false;
    property CurveCaps :TCurveCaps read FCurveCaps write FCurveCaps stored false;
    property LineCaps :TLineCaps read FLineCaps write FLineCaps stored false;
    property PolygonCaps :TPolygonCaps read FPolygonCaps write FPolygonCaps stored false;
    property TextCaps :TTextCaps read FTextCaps write FTextCaps stored false;
    property Modes :TStrings read FModes write FModes stored False;
  end;

  TMedia = class(TPersistent)
  private
    FDevice: TStrings;
    FAUX: string;
    FMIDIIn: string;
    FMixer: string;
    FWAVEOut: string;
    FWAVEIn: string;
    FMIDIOut: string;
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property Device :TStrings read FDevice write FDevice stored false;
    property WAVEIn :string read FWAVEIn write FWAVEIn stored false;
    property WAVEOut :string read FWAVEOut write FWAVEOut stored false;
    property MIDIIn :string read FMIDIIn write FMIDIIn stored false;
    property MIDIOut :string read FMIDIOut write FMIDIOut stored false;
    property AUX :string read FAUX write FAUX stored false;
    property Mixer :string read FMixer write FMixer stored false;
  end;

  TDevices = class(TPersistent)
  private
    FKeyboard: TStrings;
    FMouse: TStrings;
    FSD: TStrings;
    FSCSI: TStrings;
    FUSB: TStrings;
    FModem: TStrings;
    FMonitor: TStrings;
    FPrinter: TStrings;
    FPort: TStrings;
    FPCMCIA: TStrings;
    FInfrared: TStrings;
    FImage: TStrings;
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property Monitor :TStrings read FMonitor write FMonitor stored false;
    property Printer :TStrings read FPrinter write FPrinter stored false;
    property Keyboard :TStrings read FKeyboard write FKeyboard stored false;
    property Mouse :TStrings read FMouse write FMouse stored false;
    property SystemDevice :TStrings read FSD write FSD stored false;
    property USB :TStrings read FUSB write FUSB stored false;
    property SCSI :TStrings read FSCSI write FSCSI stored false;
    property Modem :TStrings read FModem write FModem stored false;
    property Port :TStrings read FPort write FPort stored false;
    property PCMCIA :TStrings read FPCMCIA write FPCMCIA stored False;
    property Infrared :TStrings read FInfrared write FInfrared stored False;
    property Image :TStrings read FImage write FImage stored False;
  end;

  TEngines = class(TPersistent)
  private
    FBDE: string;
    FODBC: string;
  public
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property ODBC :string read FODBC write FODBC stored false;
    property BDE :string read FBDE write FBDE stored false;
  end;

  TAPM = class(TPersistent)
  private
    FBatteryLifePercent: Byte;
    FBatteryLifeFullTime: DWORD;
    FBatteryLifeTime: DWORD;
    FACPowerStatus: string;
    FBatteryChargeStatus: string;
  public
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property ACPowerStatus :string read FACPowerStatus write FACPowerStatus stored false;
    property BatteryChargeStatus :string read FBatteryChargeStatus write FBatteryChargeStatus stored false;
    property BatteryLifePercent :Byte read FBatteryLifePercent write FBatteryLifePercent stored false;
    property BatteryLifeTime :DWORD read FBatteryLifeTime write FBatteryLifeTime stored false;
    property BatteryLifeFullTime :DWORD read FBatteryLifeFullTime write FBatteryLifeFullTime stored false;
  end;

  TDirectX = class(TPersistent)
  private
    FVersion: string;
    FDirect3D: TStrings;
    FDirectPlay: TStrings;
    FDirectMusic: TStrings;
  public
    constructor Create;
    destructor Destroy; override;
    procedure GetInfo;
    procedure Report(var sl :TStringList);
  published
    property Version :string read FVersion write FVersion stored false;
    property Direct3D :TStrings read FDirect3D write FDirect3D stored false;
    property DirectPlay :TStrings read FDirectPlay write FDirectPlay stored false;
    property DirectMusic :TStrings read FDirectMusic write FDirectMusic stored false;
  end;

  TMSystemInfo = class(TComponent)
  private
    FCPU: TCPU;
    FMemory: TMemory;
    FOS :TOperatingSystem;
    FDisk :TDisk;
    FWorkstation: TWorkstation;
    FNetwork: TNetwork;
    FDisplay: TDisplay;
    FEngines: TEngines;
    FDevices: TDevices;
    FAPM :TAPM;
    FAbout: string;
    FDirectX: TDirectX;
    FMedia: TMedia;
    procedure SetAbout(const Value: string);
  public
    constructor Create(AOwner :TComponent); override;
    destructor Destroy; override;
    procedure Refresh;
    procedure Report(var sl :TStringList);
  published
    property About :string read FAbout write SetAbout;
    property CPU :TCPU read FCPU write FCPU;
    property Memory :TMemory read FMemory write FMemory;
    property OS :TOperatingSystem read FOS write FOS;
    property Disk :TDisk read FDisk write FDisk;
    property Workstation :TWorkstation read FWorkstation write FWorkstation;
    property Network :TNetwork read FNetwork write FNetwork;
    property Display :TDisplay read FDisplay write FDisplay;
    property Media :TMedia read FMedia write FMedia;
    property Devices :TDevices read FDevices write FDevices;
    property Engines :TEngines read FEngines write FEngines;
    property APM :TAPM read FAPM write FAPM;
    property DirectX :TDirectX read FDirectX write FDirectX;
  end;


  function FormatSeconds(TotalSeconds :comp; WholeSecondsOnly,
                         DisplayAll, DTFormat :Boolean) :String;
  function ReadVerInfo(const fn :string; var Desc :string) :string;
  function ReadRegInfo(ARoot :hkey; AKey, AValue :string) :string;
  function GetTimeStamp :TLargInt;
  function GetTicksPerSecond(Iterations :Word) :Comp;
  function GetWindowInfo(wh: hwnd): PWindow;
  {$IFDEF ONLYWIN9X}
  function GetFreeSysRes(SysRes: Word): Word;
  {$ENDIF}
  procedure GetEnvironment(EnvList :tstringlist);
  function GetWinSysDir: string;

  procedure Register;

const
  ID_Bit = $200000;    // EFLAGS ID bit

  CPUVendorIDs :array[0..5] of string = ('GenuineIntel',
                                         'UMC UMC UMC',
                                         'AuthenticAMD',
                                         'CyrixInstead',
                                         'NexGenDriven',
                                         'CentaurHauls');

  CPUVendors :array[0..5] of string = ('Intel',
                                       'UMC',
                                       'AMD',
                                       'Cyrix',
                                       'NexGen',
                                       'CentaurHauls');

var
  IsNT,IS95,Is98,Is2000,IsOSR2: Boolean;
  WindowsUser, MachineName: string;
  Platform: TPlatformType;

{$IFDEF WIN32}
function Netbios(P: PNCB): Char; stdcall;
{$ENDIF}

function NetbiosCmd(var NCB: TNCB): Word;

implementation

uses ShlObj;

var
  VLevel, VFamily, VModel, VStepping, VTyp :Byte;
  VFeatures :LongInt;
  ClassKey: string;
const
  DescValue = 'DriverDesc';

{$IFDEF WIN32}
function Netbios; external 'netapi32.dll' name 'Netbios';
{$ENDIF}  

{$IFDEF ONLYWIN9X}
type
  function LoadLibrary16(LibraryName: PChar): THandle; stdcall; external kernel32 index 35;
  procedure FreeLibrary16(HInstance: THandle); stdcall; external kernel32 index 36;
  function GetProcAddress16(Hinstance: THandle; ProcName: PChar): Pointer; stdcall; external kernel32 index 37;
  procedure QT_Thunk; cdecl; external kernel32 name 'QT_Thunk';
var
  hInst16: THandle;
  SR: Pointer;

function GetFreeSysResources(SysRes: Word): Word;
var
  Thunks: Array[0..$20] of Word;
begin
  Thunks[0]:=hInst16;
  hInst16:=LoadLibrary16('user.exe');
  if hInst16<32 then
    raise Exception.Create('Can''t load USER.EXE!');
  FreeLibrary16(hInst16);
  SR:=GetProcAddress16(hInst16,'GetFreeSystemResources');
  if not Assigned(SR) then
    raise Exception.Create('Can''t get address of GetFreeSystemResources');
  asm
    push SysRes       // push arguments
    mov edx, SR       // load 16-bit procedure pointer
    call QT_Thunk     // call thunk
    mov Result, ax    // save the result
  end;
end;
{$ENDIF}

function NetbiosCmd(var NCB: TNCB): Word;
begin
{$IFNDEF WIN32}
  asm
    push bp                   { save bp }
    push ss                   { save ss }
    push ds                   { save ds }
    les  bx, NCB              { get segment/offset address of NCB }
    call NetBiosCall;         { 16 bit Windows Netbios call }
    xor  ah,ah
    mov  @Result, ax          { store return code }
    pop  ds                   { restore ds }
    pop  ss                   { restore ss }
    pop  bp                   { restore bp }
  end;
{$ELSE}
  Result:=Word(Netbios(PNCB(@NCB)));
{$ENDIF}
end;

function NbLanaEnum: TLana_Enum;
var
  NCB: TNCB;
  L_Enum: TLana_Enum;
  RetCode: Word;
begin
{$IFDEF WIN32}
  FillChar(NCB, SizeOf(NCB),0);
  FillChar(L_Enum, SizeOf(TLana_Enum),0);
  NCB.Command:=NCB_ENUM;
  NCB.Buf:=@L_Enum;
  NCB.Length:=Sizeof(L_Enum);
  RetCode:=NetBiosCmd(NCB);
  if RetCode<>NRC_GOODRET then begin
    L_Enum.Length:=0;
    L_Enum.Lana[0]:=Byte(RetCode);
  end;
{$ELSE}
  L_Enum.Length:=1;
  L_Enum.Lana[0]:=0;
{$ENDIF}
  Result:=L_Enum;
end;

function NbReset(l: Byte): Word;
var
  NCB: TNCB;
begin
{$IFNDEF WIN32}
  Result:=NRC_GOODRET;
{$ELSE}
  FillChar(NCB,SizeOf(NCB),0);
  NCB.Command:=NCB_RESET;
  NCB.Lana_Num:=l;
  Result:=NetBiosCmd(NCB);
{$ENDIF}
end;

function NbGetMacAddr(LanaNum: Integer): String;
var
  NCB: TNCB;
  AdpStat: TAdpStat;
  RetCode: Word;
begin
  FillChar(NCB,SizeOf(NCB),0);
  FillChar(AdpStat,SizeOf(AdpStat),0);
  NCB.Command:=NCB_ADPSTAT;
  NCB.Buf:=@AdpStat;
  NCB.Length:=Sizeof(AdpStat);
  FillChar(NCB.CallName,Sizeof(TNBName),$20);
  NCB.CallName[0]:=Byte('*');
  NCB.Lana_Num:=LanaNum;
  RetCode:=NetBiosCmd(NCB);
  if RetCode=NRC_GOODRET then begin
    Result:=Format('%2.2x:%2.2x:%2.2x:%2.2x:%2.2x:%2.2x',
                   [AdpStat.ID[0],
                   AdpStat.ID[1],
                   AdpStat.ID[2],
                   AdpStat.ID[3],
                   AdpStat.ID[4],
                   AdpStat.ID[5]
                   ]);
  end else
    Result:='??:??:??:??:??:??';
end;

procedure GetEnvironment(EnvList :tstringlist);
var
  c,i :dword;
  b :pchar;
  s :string;
begin
  EnvList.Clear;
  c:=1024;
  b:=GetEnvironmentStrings;
  i:=0;
  s:='';
  while i<c do begin
    if b[i]<>#0 then
      s:=s+b[i]
    else begin
      if s='' then
        break;
      EnvList.Add(s);
      s:='';
    end;
    inc(i);
  end;
  FreeEnvironmentStrings(b);
end;

function GetWinSysDir: string;
var
  n: integer;
  p: PChar;
begin
  n:=MAX_PATH;
  p:=stralloc(n);
  getwindowsdirectory(p,n);
  result:=strpas(p)+';';
  getsystemdirectory(p,n);
  Result:=Result+strpas(p)+';';
end;

procedure Register;
begin
  RegisterComponents('MiTeC',[TMSystemInfo]);
end;

function GetCPUIDFlags: DWORD; assembler; register;
asm
	PUSH    EBX	   	//Save registers
	PUSH    EDI
	MOV     EAX,1 	        //Set up for CPUID
	DW      $A20F 	        //CPUID OpCode
	MOV @Result,EDX	        //Put the flag array into a DWord
	POP     EDI	       	//Restore registers
	POP     EBX
end;

function GetTimeStampHi: DWORD; assembler; register;
asm
        DW      $310F        //RDTSC Command
        MOV @Result, EDX;
end;

function GetTimeStampLo: DWORD; assembler; register;
asm
	DW      $310F       //RDTSC Command
	MOV @Result, EAX;
end;

function GetTimeStamp :TLargInt;
begin
  result.QuadPart:=0;
  if (GetCPUIDFlags and 16) <> 16 then
    exit;
  result.HighPart:=DWORD(GetTimeStampHi);
  result.LowPart:=GetTimeStampLo;
end;

function GetTicksPerSecond(Iterations :Word) :Comp;
var
  Freq ,PerfCount,Target :int64;
  StartTime, EndTime, Elapsed :TLargInt;

  procedure StartTimer;
  begin
    StartTime:=GetTimeStamp;
    EndTime.QuadPart:=0;
    Elapsed.QuadPart:=0;
  end;

  procedure StopTimer;
  begin
    EndTime:=GetTimeStamp;
    Elapsed.QuadPart:=(EndTime.QuadPart-StartTime.QuadPart);
  end;

begin
  Result:=0;
  if not QueryPerformanceFrequency(Freq) then
    exit;
  QueryPerformanceCounter(PerfCount);
  {$IFDEF D4PLUS}
  Target:=PerfCount+(Freq*Iterations);
  {$ELSE}
  Target.QuadPart:=PerfCount.QuadPart+(Freq.QuadPart*Iterations);
  {$ENDIF}
  StartTimer;
  repeat
    QueryPerformanceCounter(PerfCount);
  {$IFDEF D4PLUS}
  until (PerfCount>=Target);
  {$ELSE}
  until (PerfCount.QuadPart>=Target.QuadPart);
  {$ENDIF}
  StopTimer;
  Result:=(Elapsed.QuadPart/Iterations);
end;

function GetStrFromBuf(Buffer :pchar) :string;
var
  i,j :integer;
begin
  result:='';
  j:=0;
  i:=0;
  repeat
    if buffer[i]<>#0 then begin
      result:=result+buffer[i];
      j:=0;
    end else
      inc(j);
    inc(i);
  until j>1;
end;

function GetKey(StartKey, Value, Data :string) :string;
var
  vn,kn :tstringlist;
  regbase :TRegistry;

  procedure EnumKeys(aregbase :TRegistry; aroot: string; akn :tstringlist);
  var
    kn :tstringlist;
    i :integer;
  begin
    for i:=0 to akn.count-1 do
      with aregbase do begin
        closekey;
        if OpenKey(aroot+'\'+akn[i],false) then begin
          getvaluenames(vn);
          if vn.indexof(value)>-1 then begin
            if ReadString(value)=data then begin
              result:=aroot+'\'+akn[i];
              break;
            end;
          end else
            if hassubkeys then begin
              kn:=tstringlist.create;
              getkeynames(kn);
              enumkeys(aregbase,aroot+'\'+akn[i],kn);
              if result<>'' then
                break;
              kn.free;
            end;
        end;
      end;
  end;

begin
  result:='';
  regbase:=TRegistry.create;
  with regbase do begin
    rootkey:=HKEY_LOCAL_MACHINE;
    vn:=tstringlist.create;
    kn:=tstringlist.create;
    if OpenKey(startkey,false) then begin
      getkeynames(kn);
      enumkeys(regbase,startkey,kn);
      closekey;
    end;
    vn.free;
    kn.free;
    free;
  end;
end;

function GetWindowInfo(wh: hwnd): PWindow;
var
  cn,wn :pchar;
  n, wpid,tid :longword;
begin
  n:=255;
  wn:=stralloc(n);
  cn:=stralloc(n);
  tid:=GetWindowThreadProcessId(wh,@wpid);
  getclassname(wh,cn,n);
  getwindowtext(wh,wn,n);
  new(result);
  result^.ClassName:=strpas(cn);
  result^.Text:=strpas(wn);
  result^.Handle:=wh;
  result^.Process:=wpid;
  result^.Thread:=tid;
  result^.ParentWin:=getwindowlong(wh,GWL_HWNDPARENT);
  result^.WndProc:=getwindowlong(wh,GWL_WNDPROC);
  result^.Instance:=getwindowlong(wh,GWL_HINSTANCE);
  result^.ID:=getwindowlong(wh,GWL_ID);
  result^.UserData:=getwindowlong(wh,GWL_USERDATA);
  result^.Style:=getwindowlong(wh,GWL_STYLE);
  result^.ExStyle:=getwindowlong(wh,GWL_EXSTYLE);
  getwindowrect(wh,result^.Rect);
  getclientrect(wh,result^.ClientRect);
  result^.Atom:=getclasslong(wh,GCW_ATOM);
  result^.ClassBytes:=getclasslong(wh,GCL_CBCLSEXTRA);
  result^.WinBytes:=getclasslong(wh,GCL_CBWNDEXTRA);
  result^.ClassWndProc:=getclasslong(wh,GCL_WNDPROC);
  result^.ClassInstance:=getclasslong(wh,GCL_HMODULE);
  result^.Background:=getclasslong(wh,GCL_HBRBACKGROUND);
  result^.Cursor:=getclasslong(wh,GCL_HCURSOR);
  result^.Icon:=getclasslong(wh,GCL_HICON);
  result^.ClassStyle:=getclasslong(wh,GCL_STYLE);
  result^.Styles:=tstringlist.create;
  result^.visible:=iswindowvisible(wh);
  if not(result^.ExStyle and WS_BORDER=0) then
    result^.Styles.add('WS_BORDER');
  if not(result^.Style and WS_CHILD=0) then
    result^.Styles.add('WS_CHILD');
  if not(result^.Style and WS_CLIPCHILDREN=0) then
    result^.Styles.add('WS_CLIPCHILDREN');
  if not(result^.Style and WS_CLIPSIBLINGS=0) then
    result^.Styles.add('WS_CLIPSIBLINGS');
  if not(result^.Style and WS_DISABLED=0) then
    result^.Styles.add('WS_DISABLED');
  if not(result^.Style and WS_DLGFRAME=0) then
    result^.Styles.add('WS_DLGFRAME');
  if not(result^.Style and WS_GROUP=0) then
    result^.Styles.add('WS_GROUP');
  if not(result^.Style and WS_HSCROLL=0) then
    result^.Styles.add('WS_HSCROLL');
  if not(result^.Style and WS_MAXIMIZE=0) then
    result^.Styles.add('WS_MAXIMIZE');
  if not(result^.Style and WS_MAXIMIZEBOX=0) then
    result^.Styles.add('WS_MAXIMIZEBOX');
  if not(result^.Style and WS_MINIMIZE=0) then
    result^.Styles.add('WS_MINIMIZE');
  if not(result^.Style and WS_MINIMIZEBOX=0) then
    result^.Styles.add('WS_MINIMIZEBOX');
  if not(result^.Style and WS_OVERLAPPED=0) then
    result^.Styles.add('WS_OVERLAPPED');
  if not(result^.Style and WS_POPUP=0) then
    result^.Styles.add('WS_POPUP');
  if not(result^.Style and WS_SYSMENU=0) then
    result^.Styles.add('WS_SYSMENU');
  if not(result^.Style and WS_TABSTOP=0) then
    result^.Styles.add('WS_TABSTOP');
  if not(result^.Style and WS_THICKFRAME=0) then
    result^.Styles.add('WS_THICKFRAME');
  if not(result^.Style and WS_VISIBLE=0) then
    result^.Styles.add('WS_VISIBLE');
  if not(result^.Style and WS_VSCROLL=0) then
    result^.Styles.add('WS_VSCROLL');
  result^.ExStyles:=tstringlist.create;
  if not(result^.ExStyle and WS_EX_ACCEPTFILES=0) then
    result^.ExStyles.add('WS_EX_ACCEPTFILES');
  if not(result^.ExStyle and WS_EX_DLGMODALFRAME=0) then
    result^.ExStyles.add('WS_EX_DLGMODALFRAME');
  if not(result^.ExStyle and WS_EX_NOPARENTNOTIFY=0) then
    result^.ExStyles.add('WS_EX_NOPARENTNOTIFY');
  if not(result^.ExStyle and WS_EX_TOPMOST=0) then
    result^.ExStyles.add('WS_EX_TOPMOST');
  if not(result^.ExStyle and WS_EX_TRANSPARENT=0) then
    result^.ExStyles.add('WS_EX_TRANSPARENT');
  if not(result^.ExStyle and WS_EX_MDICHILD=0) then
    result^.ExStyles.add('WS_EX_MDICHILD');
  if not(result^.ExStyle and WS_EX_TOOLWINDOW=0) then
    result^.ExStyles.add('WS_EX_TOOLWINDOW');
  if not(result^.ExStyle and WS_EX_WINDOWEDGE=0) then
    result^.ExStyles.add('WS_EX_WINDOWEDGE');
  if not(result^.ExStyle and WS_EX_CLIENTEDGE =0) then
    result^.ExStyles.add('WS_EX_CLIENTEDGE');
  if not(result^.ExStyle and WS_EX_CONTEXTHELP=0) then
    result^.ExStyles.add('WS_EX_CONTEXTHELP');
  if not(result^.ExStyle and WS_EX_RIGHT=0) then
    result^.ExStyles.add('WS_EX_RIGHT')
  else
    result^.ExStyles.add('WS_EX_LEFT');
  if not(result^.ExStyle and WS_EX_RTLREADING=0) then
    result^.ExStyles.add('WS_EX_RTLREADING')
  else
    result^.ExStyles.add('WS_EX_LTRREADING');
  if not(result^.ExStyle and WS_EX_LEFTSCROLLBAR=0) then
    result^.ExStyles.add('WS_EX_LEFTSCROLLBAR')
  else
    result^.ExStyles.add('WS_EX_RIGHTSCROLLBAR');
  if not(result^.ExStyle and WS_EX_CONTROLPARENT=0) then
    result^.ExStyles.add('WS_EX_CONTROLPARENT');
  if not(result^.ExStyle and WS_EX_STATICEDGE =0) then
    result^.ExStyles.add('WS_EX_STATICEDGE');
  if not(result^.ExStyle and WS_EX_APPWINDOW=0) then
    result^.ExStyles.add('WS_EX_APPWINDOW');
  result^.ClassStyles:=tstringlist.create;
  if not(result^.ClassStyle and CS_BYTEALIGNCLIENT=0) then
    result^.ClassStyles.add('CS_BYTEALIGNCLIENT');
  if not(result^.ClassStyle and CS_VREDRAW=0) then
    result^.ClassStyles.add('CS_VREDRAW');
  if not(result^.ClassStyle and CS_HREDRAW=0) then
    result^.ClassStyles.add('CS_HREDRAW');
  if not(result^.ClassStyle and CS_KEYCVTWINDOW=0) then
    result^.ClassStyles.add('CS_KEYCVTWINDOW');
  if not(result^.ClassStyle and CS_DBLCLKS=0) then
    result^.ClassStyles.add('CS_DBLCLKS');
  if not(result^.ClassStyle and CS_OWNDC=0) then
    result^.ClassStyles.add('CS_OWNDC');
  if not(result^.ClassStyle and CS_CLASSDC=0) then
    result^.ClassStyles.add('CS_CLASSDC');
  if not(result^.ClassStyle and CS_PARENTDC=0) then
    result^.ClassStyles.add('CS_PARENTDC');
  if not(result^.ClassStyle and CS_NOKEYCVT=0) then
    result^.ClassStyles.add('CS_NOKEYCVT');
  if not(result^.ClassStyle and CS_NOCLOSE=0) then
    result^.ClassStyles.add('CS_NOCLOSE');
  if not(result^.ClassStyle and CS_SAVEBITS=0) then
    result^.ClassStyles.add('CS_SAVEBITS');
  if not(result^.ClassStyle and CS_BYTEALIGNWINDOW=0) then
    result^.ClassStyles.add('CS_BYTEALIGNWINDOW');
  if not(result^.ClassStyle and CS_GLOBALCLASS=0) then
    result^.ClassStyles.add('CS_GLOBALCLASS');
  strdispose(wn);
  strdispose(cn);
end;

function Bool2YN(b :boolean) :string;
begin
  if b then
    result:='Yes'
  else
    result:='No';
end;

function GetClassDevices(AStartKey,AClassName,AValueName :string; var AResult :TStrings) :string;
var
  i,j :integer;
  sl :TStringList;
  s,rclass :string;
const
  rvClass = 'Class';
  rvLink = 'Link';
begin
  Result:='';
  AResult.Clear;
  with TRegistry.Create do begin
    RootKey:=HKEY_LOCAL_MACHINE;
    if OpenKey(AStartKey,false) then begin
      sl:=TStringList.Create;
      GetKeyNames(sl);
      CloseKey;
      for i:=0 to sl.Count-1 do
        if OpenKey(AStartKey+'\'+sl[i],false) then begin
          if ValueExists(rvClass) then begin
            rclass:=UpperCase(ReadString(rvClass));
            if rclass=UpperCase(AClassName) then begin
              if not IsNT then begin
                s:=UpperCase(ReadString(rvLink));
                CloseKey;
                if not OpenKey(AStartKey+'\'+s,False) then
                  Exit;
              end else
                s:=sl[i];
              Result:=AStartKey+'\'+s;
              GetKeyNames(sl);
              CloseKey;
              for j:=0 to sl.count-1 do
                if OpenKey(AStartKey+'\'+s+'\'+sl[j],false) then begin
                  if ValueExists(AValueName) then
                    AResult.Add(ReadString(AValueName));
                  CloseKey;
                end;
                Break;
            end;
          end;
          CloseKey;
        end;
      sl.free;
    end;
    free;
  end;
end;

function IsOSNT :boolean;
var
  OS :TOSVersionInfo;
begin
  ZeroMemory(@OS,SizeOf(OS));
  OS.dwOSVersionInfoSize:=SizeOf(OS);
  GetVersionEx(OS);
  result:=OS.dwPlatformId=VER_PLATFORM_WIN32_NT;
end;

function IsOS95 :boolean;
var
  OS :TOSVersionInfo;
begin
  ZeroMemory(@OS,SizeOf(OS));
  OS.dwOSVersionInfoSize:=SizeOf(OS);
  GetVersionEx(OS);
  result:=(OS.dwMajorVersion>=4) and (OS.dwMinorVersion=0) and (OS.dwPlatformId=VER_PLATFORM_WIN32_WINDOWS);
end;

function IsOS98 :boolean;
var
  OS :TOSVersionInfo;
begin
  ZeroMemory(@OS,SizeOf(OS));
  OS.dwOSVersionInfoSize:=SizeOf(OS);
  GetVersionEx(OS);
  result:=(OS.dwMajorVersion>=4) and (OS.dwMinorVersion>0) and (OS.dwPlatformId=VER_PLATFORM_WIN32_WINDOWS);
end;

function IsOSOSR2 :boolean;
var
  OS :TOSVersionInfo;
begin
  ZeroMemory(@OS,SizeOf(OS));
  OS.dwOSVersionInfoSize:=SizeOf(OS);
  GetVersionEx(OS);
  result:=(OS.dwMajorVersion>=4) and (OS.dwMinorVersion=0) and (lo(OS.dwBuildNumber)>1000) and (OS.dwPlatformId=VER_PLATFORM_WIN32_WINDOWS);
end;

function IsOS2000 :boolean;
var
  OS :TOSVersionInfo;
begin
  ZeroMemory(@OS,SizeOf(OS));
  OS.dwOSVersionInfoSize:=SizeOf(OS);
  GetVersionEx(OS);
  result:=(OS.dwMajorVersion>=5) and (OS.dwPlatformId=VER_PLATFORM_WIN32_NT);
end;

function GetPlatform: TPlatformType;
begin
  Result:=os9x;
  if isNT then begin
    if is2000 then
      Result:=os2K
    else
      Result:=osNT4;
  end;
end;

function FormatSeconds(TotalSeconds :comp; WholeSecondsOnly, DisplayAll, DTFormat :Boolean) :String;
var
 lcenturies,lyears,lmonths,lminutes,lhours,ldays,lweeks :word;
 lSecs :double;
 s :array[1..8] of string;
 SecondsPerCentury :comp;
 FS :string;
begin
  if WholeSecondsOnly then
    FS:='%.0f'
  else
    FS:='%.2f';
  SecondsPerCentury:=36550 * 24;
  SecondsPerCentury:= SecondsPerCentury * 3600;
  lcenturies:=Trunc(TotalSeconds / SecondsPerCentury);
  TotalSeconds:=TotalSeconds-(lcenturies * SecondsPerCentury);
  lyears:=Trunc(TotalSeconds / (365.5 * 24 * 3600));
  TotalSeconds:=TotalSeconds-(lyears * (365.5 * 24 * 3600));
  lmonths:=Trunc(TotalSeconds / (31 * 24 * 3600));
  TotalSeconds:=TotalSeconds-(lmonths * (31 * 24 * 3600));
  lweeks:=Trunc(TotalSeconds / (7 * 24 * 3600));
  TotalSeconds:=TotalSeconds-(lweeks * (7 * 24 * 3600));
  ldays:=Trunc(TotalSeconds / (24 * 3600));
  TotalSeconds:=TotalSeconds-(ldays * (24 * 3600));
  lhours:=Trunc(TotalSeconds / 3600);
  TotalSeconds:=TotalSeconds-(lhours * 3600);
  lminutes:=Trunc(TotalSeconds / 60);
  TotalSeconds:=TotalSeconds-(lminutes * 60);
  If WholeSecondsOnly then
    lsecs:=Trunc(TotalSeconds)
  else
    lsecs:=TotalSeconds;
  if lCenturies=1 then
    s[1]:=' Century, '
  else
    s[1]:=' Centuries, ';
  if lyears=1 then
    s[2]:=' Year, '
  else
    s[2]:=' Years, ';
  if lmonths=1 then
    s[3]:=' Month, '
  else
    s[3]:=' Months, ';
  if lweeks=1 then
    s[4]:=' Week, '
  else
    s[4]:=' Weeks, ';
  if ldays=1 then
    s[5]:=' Day, '
  else
    s[5]:=' Days, ';
  if lhours=1 then
    s[6]:=' Hour, '
  else
    s[6]:=' Hours, ';
  if lminutes=1 then
    s[7]:=' Minute, '
  else
    s[7]:=' Minutes, ';
  if lsecs=1 then
    s[8]:=' Second.'
  else
    s[8]:=' Seconds.';
  If DisplayAll then begin
    if dtformat then
      result:=Format('%2.2d.%2.2d.%2.2d %2.2d:%2.2d:%2.2d',
                     [lyears,lmonths,ldays+lweeks*7,lhours,lminutes,round(lSecs)])
    else
      Result:= Format('%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s' + FS + '%s',
                     [lcenturies,s[1],lyears,s[2],lmonths,s[3],lweeks,s[4],ldays,s[5],lhours,s[6],lminutes,s[7],lSecs,s[8]]);

  end else begin
    if dtformat then
      result:=Format('%2.2d:%2.2d:%2.2d',
                     [lhours,lminutes,round(lSecs)])
    else begin
      if lCenturies>=1 then
        Result:= Format('%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s' + FS + '%s',
                        [lcenturies,s[1],lyears,s[2],lmonths,s[3],lweeks,s[4],ldays,s[5],lhours,s[6],lminutes,s[7],lsecs,s[8]])
      else
        if lyears>=1 then
          Result:= Format('%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s' + FS + '%s',
                          [lyears,s[2],lmonths,s[3],lweeks,s[4],ldays,s[5],lhours,s[6],lminutes,s[7],lsecs,s[8]])
      else
       if lmonths>=1 then
         Result:= Format('%.0d%s%.0d%s%.0d%s%.0d%s%.0d%s' + FS + '%s',
                         [lmonths,s[3],lweeks,s[4],ldays,s[5],lhours,s[6],lminutes,s[7],lsecs,s[8]])
       else
         if lweeks>=1 then
           Result:= Format('%.0d%s%.0d%s%.0d%s%.0d%s' + FS + '%s',
                           [lweeks,s[4],ldays,s[5],lhours,s[6],lminutes,s[7],lsecs,s[8]])
         else
           if ldays>=1 then
             Result:= Format('%.0d%s%.0d%s%.0d%s' + FS + '%s',
                             [ldays,s[5],lhours,s[6],lminutes,s[7],lsecs,s[8]])
           else
             if lhours>=1 then
               Result:= Format('%.0d%s%.0d%s' + FS + '%s',
                               [lhours,s[6],lminutes,s[7],lsecs,s[8]])
             else
               if lminutes>=1 then
                 Result:= Format('%.0d%s' + FS + '%s',[lminutes,s[7],lsecs,s[8]])
               else
                 Result:= Format(FS + '%s',[lsecs,s[8]]);
    end;
  end;
end;

function ReadRegInfo(ARoot :hkey; AKey, AValue :string) :string;
begin
  with TRegistry.create do begin
    result:='';
    rootkey:=aroot;
    if keyexists(akey) then begin
      OpenKey(akey,false);
      if ValueExists(avalue) then begin
        case getdatatype(avalue) of
          rdstring: result:=ReadString(avalue);
          rdinteger: result:=inttostr(readinteger(avalue));
        end;
      end;
      closekey;
    end;
    free;
  end;
end;

function ReadVerInfo(const fn :string; var Desc :string) :string;
var
  VersionHandle,VersionSize :dword;
  PItem,PVersionInfo :pointer;
  FixedFileInfo :PVSFixedFileInfo;
  il :uint;
  version :string;
  p :array [0..MAX_PATH - 1] of char;
begin
  version:='';
  desc:='';
  result:='';
  if fn<>'' then begin
    strpcopy(p,fn);
    versionsize:=getfileversioninfosize(p,versionhandle);
    if versionsize=0 then
      exit;
    getMem(pversioninfo,versionsize);
    try
      if getfileversioninfo(p,versionhandle,versionsize,pversioninfo) then begin
        if verqueryvalue(pversioninfo,'\',pointer(fixedfileinfo),il) then
          version:=inttostr(hiword(fixedfileinfo^.dwfileversionms))+
                   '.'+inttostr(loword(fixedfileinfo^.dwfileversionms))+
                   '.'+inttostr(hiword(fixedfileinfo^.dwfileversionls))+
                   '.'+inttostr(loword(fixedfileinfo^.dwfileversionls));
          if verqueryvalue(pversioninfo,pchar('\StringFileInfo\040904E4\FileDescription'),pitem,il) then
            desc:=pchar(pitem);
      end;
    finally
      freeMem(pversioninfo,versionsize);
      result:=version;
    end;
  end;
end;

function GetMachine :string;
var
  n :dword;
  buf :pchar;
const
  rkMachine = {HKEY_LOCAL_MACHINE\}'SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName';
    rvMachine = 'ComputerName';
begin
  n:=255;
  buf:=stralloc(n);
  GetComputerName(buf,n);
  result:=strpas(buf);
  strdispose(buf);
  with TRegistry.Create do begin
    rootkey:=HKEY_LOCAL_MACHINE;
    if OpenKey(rkMachine,false) then begin
      if ValueExists(rvMachine) then
        result:=ReadString(rvMachine);
      closekey;
    end;
    free;
  end;
end;

function GetUser :string;
var
  n :dword;
  buf :pchar;
begin
  n:=255;
  buf:=stralloc(n);
  GetUserName(buf,n);
  result:=strpas(buf);
  strdispose(buf);
end;

{ TCPUFeatures }

procedure TCPUFeatures.GetFeaturesStr(AClear :boolean; AFeatures :TStringList);
begin
  if AClear then
    AFeatures.clear;
  AFeatures.Add('FXSAVE/FXRSTOR instruction: '+bool2yn(FXInstr));
  AFeatures.Add('MMX extension: '+bool2yn(MMX));
  AFeatures.Add('36bit Page Size Extension: '+bool2yn(PageSizeExt36bit));
  AFeatures.Add('Page Attribute Table: '+bool2yn(PageAttrTable));
  AFeatures.Add('CMOVcc (+FCMOVcc/F(U)COMI(P) opcodes: '+bool2yn(CMOVccOpcode));
  AFeatures.Add('Machine Check Architecture: '+bool2yn(MachineCheck));
  AFeatures.Add('Page Global Extension: '+bool2yn(PageGloablExt));
  AFeatures.Add('Memory Type Range Registers: '+bool2yn(MTRR));
  AFeatures.Add('SYSENTER/SYSEXIT extension: '+bool2yn(SYSENTERExt));
  AFeatures.Add('Processor contains an enabled APIC: '+bool2yn(APIC));
  AFeatures.Add('CMPXCHG8B instruction: '+bool2yn(CMPXCHG8B));
  AFeatures.Add('Machine Check Exception: '+bool2yn(MachineChkExc));
  AFeatures.Add('Physical Address Extension: '+bool2yn(PhysAddrExt));
  AFeatures.Add('Model Specific Registers: '+bool2yn(ModSpecReg));
  AFeatures.Add('Time Stamp Counter: '+bool2yn(TimeStampCnt));
  AFeatures.Add('Page Size Extension: '+bool2yn(PageSizeExt));
  AFeatures.Add('Debugging Extension: '+bool2yn(DebugExt));
  AFeatures.Add('Virtual Mode Extension: '+bool2yn(VirtModExt));
  AFeatures.Add('Built-In FPU: '+bool2yn(FPU));
end;

{ TCPU }

constructor TCPU.Create;
begin
  inherited;
  FFeatures:=TCPUFeatures.Create;
end;

destructor TCPU.Destroy;
begin
  FFeatures.Free;
  inherited;
end;

function TCPU.CPUIDExists: boolean; register;
asm
	PUSHFD			 //direct access to flags no possible, only via stack
	POP     EAX		 //flags to EAX
	MOV     EDX,EAX		 //save current flags
	XOR     EAX,ID_BIT	 //not ID bit
	PUSH    EAX		 //onto stack
	POPFD			 //from stack to flags, with not ID bit
	PUSHFD			 //back to stack
	POP     EAX		 //get back to EAX
	XOR     EAX,EDX		 //check if ID bit affected
	JZ      @exit		 //no, CPUID not availavle
	MOV     AL,True		 //Result=True
@exit:
end;

procedure TCPU.GetCPUID; assembler;
asm
	PUSH    EAX               //Save reg.
	PUSH    EBX
	PUSH    EDX
	PUSH    ECX
	MOV     EAX,1
	DW      $A20F             //CPUID Command Execute
	PUSH    eax
	MOV     VStepping,al      //Store Stepping
	AND     VStepping,0fh     //Stepping mask
	AND     al,0f0h           //Model mask
	SHR     al,4              //Model shift
	MOV     VModel,al         //Store Model
	AND     ax,0f00h          //Family mask
	SHR     ax,8              //Family shift
	MOV     VFamily,al        //Store Family
	AND     al,0f0h;          //Type mask
	SHR     al,4              //type shift
	MOV     VTyp,al           //Store Type
	POP     eax
	MOV     VFeatures,edx     //Store features
	POP     ECX
	POP     EDX
	POP     EBX
	POP     EAX               //Restore Reg.
end;

function TCPU.GetCPUIDLevel: integer;
begin
  VLevel:=0;
  asm
	MOV eax, 0	//  Get Level
	DB 0Fh,0a2h     //  CPUID opcode
	MOV VLevel,al
	//RET
  end;
  result:=VLevel;
End;

function TCPU.GetCPUType: integer; assembler
asm
	PUSH ebx
	PUSH ecx
	PUSH edx

	MOV ebx,esp
	AND esp,0FFFFFFFCh  //align down to nearest dword
	PUSHFD              //save original flags

// i386 CPU check
// The AC bit, bit #18, is a new bit introduced in the EFLAGS
// register on the i486 DX CPU to generate alignment faults.
// This bit can not be set on the i386 CPU.

	PUSHFD
	POP eax
	MOV ecx,eax
	XOR eax,40000h   	//toggle AC bit
	PUSH eax
	POPFD
	PUSHFD
	POP eax
	XOR eax,ecx
	MOV eax,3          //assume 80386
	JE @@end_CPUTyp   //it's a 386

// i486 DX CPU / i487 SX MCP and i486 SX CPU checking
// Checking for ability to set/clear ID flag (Bit 21) in EFLAGS
// which indicates the presence of a processor
// with the ability to use the CPUID instruction.

	PUSHFD
	POP eax
	MOV ecx,eax
	XOR eax,200000h   //toggle ID bit
	PUSH eax
	POPFD
	PUSHFD
	POP eax
	XOR eax, ecx
	MOV eax,4
	JE @@end_CPUTyp   //it's a 486 w/o support for CPUID

// Execute CPUID instruction to determine vendor, family,
// model and stepping.  The use of the CPUID instruction used
// in this program can be used for B0 and later steppings
// of the P5 processor.

	PUSH ebx        // CPUID modifies EBX  !!!
	MOV eax, 1     	// Level
	DB 0Fh,0a2h     // CPUID opcode
	MOV al,ah
	AND eax, 0FH
	POP ebx

@@end_CPUTyp:
	POPFD            // restore original flags
	MOV esp,ebx      // restore original ESP
	POP edx
	POP ecx
	POP ebx
end;

function TCPU.GetCPUVendor :string;
var
  i :integer;
  s :TStrBuf;

  function _GetCPUVendor :TStrBuf; assembler; register;
  asm
  	PUSH    ebx	       	//Save regs
	PUSH    edi
	MOV     edi,eax		//@Result (TStrBuf)
	MOV     eax,0
	DW      $A20F		//CPUID Command
	MOV     eax,ebx
	XCHG	ebx,ecx         //save ECX result
	MOV	ecx,4
  @1:
	STOSB            	//save first 4 byte
	SHR     eax,8
	LOOP    @1
	MOV     eax,edx
	MOV	ecx,4
  @2:
	STOSB            	//save middle 4 byte
	SHR     eax,8
	LOOP    @2
	MOV     eax,ebx
	MOV	ecx,4
  @3:            			//save last 4 byte
	STOSB
	SHR     eax,8
	LOOP    @3
	POP     edi		//Restore regs
	POP     ebx
  end;

begin
  i:=0;
  result:='';
  s:=_GetCPUVendor;
  repeat
    result:=result+s[i];
    inc(i);
  until i>11;
  FVendorNo:=-1;
  for i:=0 to high(CPUVendorIDs) do
    if result=CPUVendorIDs[i] then begin
      result:=CPUVendors[i];
      FVendorNo:=i;
      break;
    end;
end;

function TCPU.GetCPUVendorID :string;
begin
  case Family of
     4 :case FVendorNo Of
          0 :case Model of
               0 :result:='i80486DX-25/33';
               1 :result:='i80486DX-50';
               2 :result:='i80486SX';
               3 :result:='i80486DX2';
               4 :result:='i80486SL';
               5 :result:='i80486SX2';
               7 :result:='i80486DX2WB';
               8 :result:='i80486DX4';
	              9 :result:='i80486DX4WB';
             end;
          1 :case Model of
               1 :result:='U5D(486DX)';
	              2 :result:='U5S(486SX)';
             end;
          2 :case Model of
               3 :result:='80486DX2WT';
               7 :result:='80486DX2WB';
               8 :result:='80486DX4';
               9 :result:='80486DX4WB';
              14 :result:='5x86';
              15 :result:='5x86WB';
             end;
          3 :case Model of
               4 :result:='Cyrix Media GX';
               9 :result:='Cyrix 5x86';
             end;
        end;
     5 :case FVendorNo of
          0 :case Model of
               0 :result:='P5 A-step';
               1 :result:='P5';
               2 :result:='P54C';
               3 :result:='P24T OverDrive';
               4 :result:='P55C';
               5 :result:='DX4 OverDrive?';
               6 :result:='P5 OverDrive?';
	              7 :result:='P54C';
               8 :result:='P55C(0,25m)MMX';
             end;
          2 :case Model of
	              0 :result:='SSA5';
               1 :result:='5k86';
               2 :result:='5k86';
               3 :result:='5k86';
               6 :result:='K6';
               7 :result:='K6';
               8 :result:='K6-3D';
	              9 :result:='K6PLUS-3D';
             end;
          3 :case Model of
               0 :result:='Pentium Cx6X86 GXm';
               2 :result:='Std. Cx6x86';
               4 :result:='Cx6x86 GXm';
             end;
          else
             if FVendorNo=4 then
               result:='Nx586';
             if FVendorNo=5 then
               result:='IDT C6 (WinChip)';
	end;
     6 :case FVendorNo of
          0 :case Model of
               0 :result:='PentiumPro A-step';
               1 :result:='Pentium Pro';
               3 :result:='Pentium II';
               4 :result:='P55CT (P54 overdrive)';
               5 :result:='Pentium II 0,25m';
             end;
	  2 :case Model of
               6 :result:='K6';
               7 :result:='K6';
               8 :result:='K6-3D';
       	       9 :result:='K6PLUS-3D';
             end;
          3 :if Model=0 then
               result:='Cx6x86 MX/MII';
        end;
  end;
end;

function TCPU.GetCPUFreqEx: extended;
var
  c :comp;
begin
  c:=GetTicksPerSecond(1);
  Result:=c/1E6;
end;

function TCPU.GetSubModel :string;
begin
  case VTyp of
    3 :result:='Reserved';
    2 :result:='Secondary';
    1 :result:='OverDrive';
    0 :result:='Primary';
    else
      result:='Not Detected!';
  end;
end;

procedure TCPU.GetInfo;
var
  SI :TSystemInfo;
begin
  ZeroMemory(@SI,SizeOf(SI));
  GetSystemInfo(SI);
  Count:=SI.dwNumberOfProcessors;
  Family:=SI.dwProcessorType;
//  Vendor:=
//  VendorID:=
  CPUID:=CPUIDExists;
  if CPUID then begin
    Level:=GetCPUIDLevel;
    Freq:=Round(GetCPUFreqEx);
    Typ:=GetCPUType;
    GetCPUID;
    Typ:=VTyp;
    Family:=VFamily;
    Model:=VModel;
    Stepping:=VStepping;
    Vendor:=GetCPUVendor;
    VendorID:=GetCPUVendorID;
    SubModel:=GetSubModel;
    Features.FXInstr:=(VFeatures and $1000000)=$1000000;
    Features.MMX:=(VFeatures and $800000)=$800000;
    Features.PageSizeExt36bit:=(VFeatures and $20000)=$20000;
    Features.PageAttrTable:=(VFeatures and $10000)=$10000;
    Features.CMOVccOpcode:=(VFeatures and $8000)=$8000;
    Features.MachineCheck:=(VFeatures and $4000)=$4000;
    Features.PageGloablExt:=(VFeatures and $2000)=$2000;
    Features.MTRR:=(VFeatures and $1000)=$1000;
    Features.SYSENTERExt:=(VFeatures and $800)=$800;
    Features.APIC:=(VFeatures and $200)=$200;
    Features.CMPXCHG8B:=(VFeatures and $100)=$100;
    Features.MachineChkExc:=(VFeatures and $80)=$80;
    Features.PhysAddrExt:=(VFeatures and $40)=$40;
    Features.ModSpecReg:=(VFeatures and $20)=$20;
    Features.TimeStampCnt:=(VFeatures and $10)=$10;
    Features.PageSizeExt:=(VFeatures and 8)=8;
    Features.DebugExt:=(VFeatures and 4)=4;
    Features.VirtModExt:=(VFeatures and 2)=2;
    Features.FPU:=(VFeatures and 1)=1;
  end;
end;

procedure TCPU.Report(var sl: TStringList);
begin
  with sl do begin
    add(format('CPU: %d x %s %s - %d MHz',[self.Count,Vendor,VendorID,Freq]));
    add(format('Submodel: %s',[Submodel]));
    add(format('Model ID: Family %d  Model %d  Stepping %d  Level %d',[Family,Model,Stepping,Level]));
    add('');
    add('CPU Features:');
    Features.GetFeaturesStr(false,sl);
  end;
end;

{ TOperatingSystem }

constructor TOperatingSystem.Create;
begin
  inherited;
  FEnv:=TStringList.Create;
  FDirs:=TStringList.Create;
  FTZ:=TTimeZone.Create;
end;

destructor TOperatingSystem.Destroy;
begin
  FEnv.Free;
  FDirs.Free;
  FTZ.Free;
  inherited;
end;


procedure TOperatingSystem.GetEnvironment;
var
  c,i :dword;
  b :pchar;
  s :string;
begin
  FEnv.Clear;
  c:=1024;
  b:=GetEnvironmentStrings;
  i:=0;
  s:='';
  while i<c do begin
    if b[i]<>#0 then
      s:=s+b[i]
    else begin
      if s='' then
        break;
      FEnv.Add(s);
      s:='';
    end;
    inc(i);
  end;
  FreeEnvironmentStrings(b);
end;

function GetSpecialFolder(Handle: Hwnd; nFolder: Integer): string;
var
  PIDL: PItemIDList;
  Path: LPSTR;
begin
  Result:='';
  Path:=StrAlloc(MAX_PATH);
  SHGetSpecialFolderLocation(Handle, nFolder, PIDL);

  if SHGetPathFromIDList(PIDL, Path) then
    Result:=StrPas(Path);

  StrDispose(Path);
end;

function ReverseStr(S: string): string;
var
  l,i: integer;
begin
  l:=Length(s);
  Result:='';
  for i:=0 to l-1 do
    Result:=Result+s[l-i];
end;

procedure TOperatingSystem.GetInfo;
var
  OS :TOSVersionInfo;
  OK: Boolean;
  p: pchar;
  n: DWORD;
  WinH: HWND;
  s: string;
const
  rkOSInfo95 = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\Windows\CurrentVersion';
  rkOSInfoNT = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\Windows NT\CurrentVersion';
  rvVersionName95 = 'Version';
  rvVersionNameNT = 'CurrentType';
  rvRegOrg = 'RegisteredOrganization';
  rvRegOwn = 'RegisteredOwner';
  rvProductID = 'ProductID';

  cUserProfile = 'USERPROFILE';
  cUserProfileReg = {HKEY_CURRENT_USER\}'Software\Microsoft\Windows\CurrentVersion\ProfileList';
  cUserProfileRec = {HKEY_CURRENT_USER\}'SOFTWARE\Microsoft\Windows\CurrentVersion\ProfileReconciliation';
  cProfileDir = 'ProfileDirectory';
begin
  FDirs.Clear;
  TimeZone.GetInfo;
  ZeroMemory(@OS,SizeOf(OS));
  OS.dwOSVersionInfoSize:=SizeOf(OS);
  GetVersionEx(OS);
  MajorVersion:=OS.dwMajorVersion;
  MinorVersion:=OS.dwMinorVersion;
  BuildNumber:=word(OS.dwBuildNumber);
  case OS.dwPlatformId of
    VER_PLATFORM_WIN32s        :Platform:='Windows 3.1x';
    VER_PLATFORM_WIN32_WINDOWS :Platform:='Windows 95';
    VER_PLATFORM_WIN32_NT      :Platform:='Windows NT';
  end;
  if MajorVersion>4 then
    Platform:='Windows 2000';
  CSD:=strpas(OS.szCSDVersion);
  Version:='';
  RegisteredUser:='';
  RegisteredOrg:='';
  SerialNumber:='';
  with TRegistry.create do begin
    rootkey:=HKEY_LOCAL_MACHINE;
    if isnt then begin
      if OpenKey(rkOSInfoNT,false) then begin
        if ValueExists(rvVersionNameNT) then
          Version:=ReadString(rvVersionNameNT);
        if ValueExists(rvRegOrg) then
          RegisteredOrg:=ReadString(rvRegOrg);
        if ValueExists(rvRegOwn) then
          RegisteredUser:=ReadString(rvRegOwn);
        if ValueExists(rvProductID) then
          SerialNumber:=ReadString(rvProductID);
        closekey;
      end;
    end else begin
      if OpenKey(rkOSInfo95,false) then begin
        if ValueExists(rvVersionName95) then
          Version:=ReadString(rvVersionName95);
        if ValueExists(rvRegOrg) then
          RegisteredOrg:=ReadString(rvRegOrg);
        if ValueExists(rvRegOwn) then
          RegisteredUser:=ReadString(rvRegOwn);
        if ValueExists(rvProductID) then
          SerialNumber:=ReadString(rvProductID);
        closekey;
      end;
    end;
    rootkey:=HKEY_LOCAL_MACHINE;
    if IsNT then
      OK:=OpenKey(rkOSInfoNT,False)
    else
      OK:=OpenKey(rkOSInfo95,False);
    if OK then begin
      FDirs.Add('CommonFiles='+ReadString('CommonFilesDir'));
      FDirs.Add('ProgramFiles='+ReadString('ProgramFilesDir'));
      FDirs.Add('Device='+ReadString('DevicePath'));
      FDirs.Add('OtherDevice='+ReadString('OtherDevicePath'));
      FDirs.Add('Media='+ReadString('MediaPath'));
      FDirs.Add('Config='+ReadString('ConfigPath'));
      FDirs.Add('Wallpaper='+ReadString('WallPaperDir'));
      CloseKey;
    end;
    Free;
  end;

  n:=MAX_PATH;
  p:=StrAlloc(n);

  GetWindowsDirectory(p,n);
  FDirs.Add('Windows='+StrPas(p));

  GetSystemDirectory(p,n);
  FDirs.Add('System='+StrPas(p));

  GetTempPath(n,p);
  FDirs.Add('Temp='+StrPas(p));

  StrDispose(p);

  WinH:=GetDesktopWindow;
  FDirs.Add('AppData='+GetSpecialFolder(WinH,CSIDL_APPDATA));
  FDirs.Add('CommonDesktopDir='+GetSpecialFolder(WinH,CSIDL_COMMON_DESKTOPDIRECTORY));
  FDirs.Add('CommonAltStartUp='+GetSpecialFolder(WinH,CSIDL_COMMON_ALTSTARTUP));
  FDirs.Add('RecycleBin='+GetSpecialFolder(WinH,CSIDL_BITBUCKET));
  FDirs.Add('CommonPrograms='+GetSpecialFolder(WinH,CSIDL_COMMON_PROGRAMS));
  FDirs.Add('CommonStartMenu='+GetSpecialFolder(WinH,CSIDL_COMMON_STARTMENU));
  FDirs.Add('CommonStartup='+GetSpecialFolder(WinH,CSIDL_COMMON_STARTUP));
  FDirs.Add('CommonFavorites='+GetSpecialFolder(WinH,CSIDL_COMMON_FAVORITES));
  FDirs.Add('Cookies='+GetSpecialFolder(WinH,CSIDL_COOKIES));
  FDirs.Add('Controls='+GetSpecialFolder(WinH,CSIDL_CONTROLS));
  FDirs.Add('Desktop='+GetSpecialFolder(WinH,CSIDL_DESKTOP));
  FDirs.Add('DesktopDir='+GetSpecialFolder(WinH,CSIDL_DESKTOPDIRECTORY));
  FDirs.Add('Favorites='+GetSpecialFolder(WinH,CSIDL_FAVORITES));
  FDirs.Add('Drives='+GetSpecialFolder(WinH,CSIDL_DRIVES));
  FDirs.Add('Fonts='+GetSpecialFolder(WinH,CSIDL_FONTS));
  FDirs.Add('History='+GetSpecialFolder(WinH,CSIDL_HISTORY));
  FDirs.Add('Internet='+GetSpecialFolder(WinH,CSIDL_INTERNET));
  FDirs.Add('InternetCache='+GetSpecialFolder(WinH,CSIDL_INTERNET_CACHE));
  FDirs.Add('NetWork='+GetSpecialFolder(WinH,CSIDL_NETWORK));
  FDirs.Add('NetHood='+GetSpecialFolder(WinH,CSIDL_NETHOOD));
  FDirs.Add('MyDocuments='+GetSpecialFolder(WinH,CSIDL_PERSONAL));
  FDirs.Add('PrintHood='+GetSpecialFolder(WinH,CSIDL_PRINTHOOD));
  FDirs.Add('Printers='+GetSpecialFolder(WinH,CSIDL_PRINTERS));
  FDirs.Add('Programs='+GetSpecialFolder(WinH,CSIDL_PROGRAMS));
  FDirs.Add('Recent='+GetSpecialFolder(WinH,CSIDL_RECENT));
  FDirs.Add('SendTo='+GetSpecialFolder(WinH,CSIDL_SENDTO));
  FDirs.Add('StartMenu='+GetSpecialFolder(WinH,CSIDL_STARTMENU));
  FDirs.Add('StartUp='+GetSpecialFolder(WinH,CSIDL_STARTUP));
  FDirs.Add('Templates='+GetSpecialFolder(WinH,CSIDL_TEMPLATES));
  s:=ReverseStr(FDirs.Values['Desktop']);
  s:=ReverseStr(Copy(s,Pos('\',s)+1,255));
  FDirs.Add('Profile='+s);
  GetEnvironment;
end;

procedure TOperatingSystem.Report(var sl: TStringList);
begin
  with sl do begin
    add('Platform: '+Platform);
    add(format('Version: %s %d.%d.%d',[Version,MajorVersion,MinorVersion,BuildNumber]));
    add('CSD: '+CSD);
    add('Serial Number: '+SerialNumber);
    add('Registered User: '+RegisteredUser);
    add('Registered Organization: '+RegisteredOrg);
    add('');
    add('Environment:');
    addstrings(Environment);
    add('');
    add('Folders:');
    AddStrings(Directories);
    add('');
    add('Time Zone Information:');
    TimeZone.Report(sl);
  end;
end;

{ TDisk }

constructor TDisk.Create;
begin
  inherited;
  FHDC:=TStringList.Create;
  FFDC:=TStringList.Create;
  FCDC:=TStringList.Create;
end;

destructor TDisk.Destroy;
begin
  FHDC.Free;
  FFDC.Free;
  FCDC.Free;
  inherited;
end;

function TDisk.GetCD: byte;
var
  i :integer;
  root :pchar;
begin
  result:=0;
  root:=stralloc(255);
  for i:=1 to length(FAvailDisks) do begin
    strpcopy(root,copy(FAvailDisks,i,1)+':\');
    if getdrivetype(root)=drive_cdrom then begin
      result:=i;
      break;
    end;
  end;
  strdispose(root);
end;

function TDisk.GetDriveTypeStr(dt: TDriveType) :string;
begin
  case dt of
    dtUnknown     :result:='Unknown';
    dtNotExists   :result:='Not Exists';
    dtRemovable   :result:='Removable';
    dtFixed       :result:='Fixed';
    dtRemote      :result:='Remote';
    dtCDROM       :result:='CDROM';
    dtRAMDisk     :result:='RAMDisk';
  end;
end;

procedure TDisk.GetFileFlagsStr(AClear :boolean; var AFileFlags: TStringList);
begin
  if AClear then
    AFileFlags.Clear;
  AFileFlags.Add('Case Is Preserved: '+bool2yn(fsCaseIsPreserved in FileFlags));
  AFileFlags.Add('Case Sensitive: '+bool2yn(fsCaseSensitive in FileFlags));
  AFileFlags.Add('Unicode Stored On Disk: '+bool2yn(fsUnicodeStoredOnDisk in FileFlags));
  AFileFlags.Add('Persistent Acls: '+bool2yn(fsPersistentAcls in FileFlags));
  AFileFlags.Add('File Compression: '+bool2yn(fsFileCompression in FileFlags));
  AFileFlags.Add('Volume Is Compressed: '+bool2yn(fsVolumeIsCompressed in FileFlags));
  AFileFlags.Add('Long Filenames: '+bool2yn(fsLongFileNames in FileFlags));
  AFileFlags.Add('Encrypted File System Support: '+bool2yn(fsEncryptedFileSystemSupport in FileFlags));
  AFileFlags.Add('Object IDs Support: '+bool2yn(fsObjectIDsSupport in FileFlags));
  AFileFlags.Add('Reparse Points Support: '+bool2yn(fsReparsePointsSupport in FileFlags));
  AFileFlags.Add('Sparse Files Support: '+bool2yn(fsSparseFilesSupport in FileFlags));
  AFileFlags.Add('Disk Quotas Support: '+bool2yn(fsDiskQuotasSupport in FileFlags));
end;

procedure TDisk.GetInfo;
var
  i,n :integer;
  buf :pchar;
const
  rvHDCClass = 'hdc';
  rvFDCClass = 'fdc';
  rvCDCClass = 'Adapter';
begin
  buf:=stralloc(255);
  n:=GetLogicalDriveStrings(255,buf);
  FAvailDisks:='';
  for i:=0 to n do
    if buf[i]<>#0 then begin
      if (ord(buf[i]) in [$41..$5a]) or (ord(buf[i]) in [$61..$7a]) then
        FAvailDisks:=FAvailDisks+upcase(buf[i])
    end else
      if buf[i+1]=#0 then
        break;
  strdispose(buf);

  GetClassDevices(ClassKey,rvHDCClass,DescValue,FHDC);
  GetClassDevices(ClassKey,rvFDCClass,DescValue,FFDC);
  GetClassDevices(ClassKey,rvCDCClass,DescValue,FCDC);
end;


function TDisk.GetMediaPresent :Boolean;
var
  ErrorMode: Word;
  bufRoot :pchar;
  a,b,c,d :dword;
begin
  bufRoot:=stralloc(255);
  strpcopy(bufRoot,FDisk+'\');
  ErrorMode:=SetErrorMode(SEM_FailCriticalErrors);
  try
    try
      result:=GetDiskFreeSpace(bufRoot,a,b,c,d);
    except
      result:=False;
    end;
  finally
    strdispose(bufroot);
    SetErrorMode(ErrorMode);
  end;
end;

procedure TDisk.Report(var sl: TStringList);
var
  i :integer;
begin
  for i:=1 to length(AvailableDisks) do begin
    sl.add('');
    Drive:=copy(AvailableDisks,i,1)+':';
    sl.add(format('%s [%s] - %s',[Drive,VolumeLabel,GetDriveTypeStr(DriveType)]));
    sl.add('UNC: '+expanduncfilename(Drive));
    sl.add('Serial Number: '+SerialNumber);
    {$IFDEF D4PLUS}
    sl.add(formatfloat('Capacity: 0,## bytes',Capacity));
    sl.add(formatfloat('Free space: 0,## bytes',FreeSpace));
    {$ELSE}
    sl.add(formatfloat('Capacity: 0,## bytes',Capacity.QuadPart));
    sl.add(formatfloat('Free space: 0,## bytes',FreeSpace.QuadPart));
    {$ENDIF}
    sl.add(formatfloat('Bytes/sector: 0',BytesPerSector));
    sl.add(formatfloat('Sector/cluster: 0',SectorsPerCluster));
    sl.add(formatfloat('Free clusters: 0,##',FreeClusters));
    sl.add(formatfloat('Total clusters: 0,##',TotalClusters));
    sl.add('  File Flags:');
    GetFileFlagsStr(false,sl);
  end;
  sl.add('HD Controllers:');
  sl.addstrings(HDController);
  sl.add('');
  sl.add('FD Controllers:');
  sl.addstrings(FDController);
  sl.add('');
  sl.add('CDROM Controllers:');
  sl.addstrings(CDROMController);
  sl.add('');
end;

procedure TDisk.SetDisk(const Value: TDiskSign);
var
  BPS,TC,FC,SPC :integer;
  T,F :TLargeInteger;
  TF :PLargeInteger;
  bufRoot, bufVolumeLabel, bufFileSystem :pchar;
  MCL,Size,Flags :DWORD;
  s :string;
  {$IFNDEF D4PLUS}
  h :THandle;
  GetDiskFreeSpaceEx :function (lpDirectoryName: PChar;
                                var lpFreeBytesAvailableToCaller,
                                    lpTotalNumberOfBytes;
                                lpTotalNumberOfFreeBytes: PLargeInteger): BOOL; stdcall;
  {$ENDIF}

const
  rk2KModel = '';
begin
  FDisk:=Value;
  Size:=255;
  bufRoot:=stralloc(Size);
  strpcopy(bufRoot,FDisk+'\');
  case GetDriveType(bufRoot) of
    DRIVE_UNKNOWN     :FDriveType:=dtUnknown;
    DRIVE_NO_ROOT_DIR :FDriveType:=dtNotExists;
    DRIVE_REMOVABLE   :FDriveType:=dtRemovable;
    DRIVE_FIXED       :FDriveType:=dtFixed;
    DRIVE_REMOTE      :FDriveType:=dtRemote;
    DRIVE_CDROM       :FDriveType:=dtCDROM;
    DRIVE_RAMDISK     :FDriveType:=dtRAMDisk;
  end;
  FFileFlags:=[];
  if MediaPresent then begin
    GetDiskFreeSpace(bufRoot,FSectorsPerCluster,FBytesPerSector,FFreeClusters,FTotalClusters);
    try
      new(TF);
      {$IFDEF D4PLUS}
      SysUtils.GetDiskFreeSpaceEx(bufRoot,F,T,TF);
      FCapacity:=T;
      FFreeSpace:=F;
      {$ELSE}
      GetDiskFreeSpaceEx:=nil;
      h:=LoadLibrary('KERNEL32.DLL');
      if h>0 then
        GetDiskFreeSpaceEx:=GetProcAddress(h,'GetDiskFreeSpaceExA');
      if assigned(GetDiskFreeSpaceEx) then
        GetDiskFreeSpaceEx(bufRoot,F,T,TF);
      FCapacity:=T;
      FFreeSpace:=F;
      FreeLibrary(h);
      {$ENDIF}
      dispose(TF);
    except
      BPS:=FBytesPerSector;
      TC:=FTotalClusters;
      FC:=FFreeClusters;
      SPC:=FSectorsPerCluster;
      {$IFDEF D4PLUS}
      FCapacity:=TC*SPC*BPS;
      FFreeSpace:=FC*SPC*BPS;
      {$ELSE}
      FCapacity.QuadPart:=TC*SPC*BPS;
      FFreeSpace.QuadPart:=FC*SPC*BPS;
      {$ENDIF}
    end;
    bufVolumeLabel:=stralloc(Size);
    bufFileSystem:=stralloc(Size);
    if GetVolumeInformation(bufRoot,bufVolumeLabel,Size,@FSerial,MCL,Flags,bufFileSystem,Size) then begin;
      FVolumeLabel:=strpas(bufVolumeLabel);
      FFileSystem:=strpas(bufFileSystem);
      s:=inttohex(FSerial,8);
      FSerialNumber:=copy(s,1,4)+'-'+copy(s,5,4);
      StrDispose(bufVolumeLabel);
      StrDispose(bufFileSystem);
      StrDispose(bufRoot);
      if Flags and FS_CASE_SENSITIVE=FS_CASE_SENSITIVE then
        FFileFlags:=FFileFlags+[fsCaseSensitive];
      if Flags and FS_CASE_IS_PRESERVED=FS_CASE_IS_PRESERVED then
        FFileFlags:=FFileFlags+[fsCaseIsPreserved];
      if Flags and FS_UNICODE_STORED_ON_DISK=FS_UNICODE_STORED_ON_DISK then
        FFileFlags:=FFileFlags+[fsUnicodeStoredOnDisk];
      if Flags and FS_PERSISTENT_ACLS=FS_PERSISTENT_ACLS then
        FFileFlags:=FFileFlags+[fsPersistentAcls];
      if Flags and FS_VOL_IS_COMPRESSED=FS_VOL_IS_COMPRESSED then
        FFileFlags:=FFileFlags+[fsVolumeIsCompressed];
      if Flags and FS_FILE_COMPRESSION=FS_FILE_COMPRESSION then
        FFileFlags:=FFileFlags+[fsFileCompression];
      if MCL=255 then
        FFileFlags:=FFileFlags+[fsLongFileNames];
      if Flags and FILE_SUPPORTS_ENCRYPTION=FILE_SUPPORTS_ENCRYPTION then
        FFileFlags:=FFileFlags+[fsEncryptedFileSystemSupport];
      if Flags and FILE_SUPPORTS_OBJECT_IDS=FILE_SUPPORTS_OBJECT_IDS then
        FFileFlags:=FFileFlags+[fsObjectIDsSupport];
      if Flags and FILE_SUPPORTS_REPARSE_POINTS=FILE_SUPPORTS_REPARSE_POINTS then
        FFileFlags:=FFileFlags+[fsReparsePointsSupport];
      if Flags and FILE_SUPPORTS_SPARSE_FILES=FILE_SUPPORTS_SPARSE_FILES then
        FFileFlags:=FFileFlags+[fsSparseFilesSupport];
      if Flags and FILE_VOLUME_QUOTAS=FILE_VOLUME_QUOTAS then
        FFileFlags:=FFileFlags+[fsDiskQuotasSupport];
    end;
  end else begin
    FSectorsPerCluster:=0;
    FBytesPerSector:=0;
    FFreeClusters:=0;
    FTotalClusters:=0;
    {$IFDEF D4PLUS}
    FCapacity:=0;
    FFreeSpace:=0;
    {$ELSE}
    FCapacity.QuadPart:=0;
    FFreeSpace.QuadPart:=0;
    {$ENDIF}
    FVolumeLabel:='';
    FSerialNumber:='';
    FFileSystem:='';
    FSerial:=0;
  end;
end;

{ TWorkstation }


function TWorkstation.GetSystemUpTime: Extended;
begin
  try
    FSystemUpTime:=GetTickCount/1000;//GetTimeStamp.QuadPart/GetTicksPerSecond(1);
  except
    FSystemUpTime:=0;
  end;
  result:=FSystemUpTime;
end;

procedure TWorkstation.GetInfo;
var
  bdata :pchar;
  KeyState : TKeyBoardState;
const
  cBIOSName = $FE061;
  cBIOSDate = $FFFF5;
  cBIOSExtInfo = $FEC71;
  cBIOSCopyright = $FE091;

  rkBIOS = {HKEY_LOCAL_MACHINE\}'HARDWARE\DESCRIPTION\System';
    rvBiosDate = 'SystemBiosDate';
    rvBiosID = 'Identifier';
    rvBiosVersion = 'SystemBiosVersion';

begin
  try
    FLastBoot:=Now-(GetTimeStamp.QuadPart/GetTicksPerSecond(1))/(24*3600);
  except
    FLastBoot:=0;
  end;
  FSystemUpTime:=GetSystemUpTime;
  FName:=GetMachine;
  FUser:=GetUser;
  if isNT then begin
    with TRegistry.Create do begin
      rootkey:=HKEY_LOCAL_MACHINE;
      if OpenKey(rkBIOS,false) then begin
        if ValueExists(rvBIOSID) then
          FBiosName:=ReadString(rvBIOSID);
        if ValueExists(rvBIOSVersion) then begin
          bdata:=stralloc(255);
          try
            readbinarydata(rvBIOSVersion,bdata^,255);
            FBIOSCopyright:=strpas(pchar(bdata));
          except
          end;
        end;
        if ValueExists(rvBIOSDate) then
          FBIOSDate:=ReadString(rvBIOSDate);
        closekey;
      end;
      free;
    end;
  end else begin
    FBIOSName:=string(pchar(ptr(cBIOSName)));
    FBIOSDate:=string(pchar(ptr(cBIOSDate)));
    FBIOSCopyright:=string(pchar(ptr(cBIOSCopyright)));
    FBIOSExtendedInfo:=string(pchar(ptr(cBIOSExtInfo)));
  end;
  GetKeyboardState(KeyState);
  FCapsLock:=KeyState[VK_CAPITAL]=1;
  FNumLock:=KeyState[VK_NUMLOCK]=1;
  FScrollLock:=KeyState[VK_SCROLL]=1;
end;


procedure TWorkstation.Report(var sl: TStringList);
begin
  with sl do begin
    add('Name: '+Name);
    add('User: '+User);
    add('BIOS name: '+BIOSName);
    add('BIOS Copyright: '+BIOSCopyright);
    add('BIOS Date: '+BIOSDate);
    add('BIOS Extended info: '+BIOSExtendedInfo);
    add('Last Boot: '+datetimetostr(LastBoot));
    add('System Up Time: '+formatseconds(SystemUpTime,true,false,false));
  end;
end;

{ TWinsock }

procedure TWinsock.GetInfo;
var
  GInitData :TWSADATA;
begin
  if wsastartup($101,GInitData)=0 then begin
    FDesc:=GInitData.szDescription;
    FStat:=GInitData.szSystemStatus;
    FMajVer:=Hi(GInitData.wHighVersion);
    FMinVer:=Lo(GInitData.wHighVersion);
    wsacleanup;
  end else
    FStat:='Winsock cannot be initialized.';
end;


{ TNetwork }

function TNetwork.GetLocalIP: string;
type
  TaPInAddr = array [0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe  :PHostEnt;
  pptr :PaPInAddr;
  Buffer :array [0..63] of char;
  i :integer;
  GInitData :TWSADATA;
begin
  wsastartup($101,GInitData);
  result:='';
  GetHostName(Buffer,SizeOf(Buffer));
  phe:=GetHostByName(buffer);
  if not assigned(phe) then
    exit;
  pptr:=PaPInAddr(Phe^.h_addr_list);
  i:=0;
  while pptr^[I]<>nil do begin
    result:=Result+StrPas(inet_ntoa(pptr^[I]^))+',';
    inc(i);
  end;
  Delete(Result,Length(Result),1);
  wsacleanup;
end;

procedure TNetwork.GetInfo;
var
  L_Enum: TLana_Enum;
  RetCode: Word;
  i: integer;
  ck,dv: string;
const
  rkNetworkNT = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\Windows NT\CurrentVersion\NetworkCards\1';
  rkNetwork2K = {HKEY_LOCAL_MACHINE\}'SYSTEM\CurrentControlSet\Control\Network';

  rvNetworkNT = 'Description';

  rvNetClass = 'Net';
  rvProtoClass = 'NetTrans';
  rvServClass = 'NetService';
  rvCliClass = 'NetClient';


begin
  FWinSock.GetInfo;
  FIPAddress.CommaText:=GetLocalIP;
  FAdapter.Clear;
  if isNT and not is2000 then
    with TRegistry.Create do begin
      RootKey:=HKEY_LOCAL_MACHINE;
      if OpenKey(rkNetworkNT,false) then begin
        if ValueExists(rvNetworkNT) then
          FAdapter.Add(ReadString(rvNetworkNT));
        CloseKey;
      end;
      Free;
    end
  else
    GetClassDevices(ClassKey,rvNetClass,DescValue,FAdapter);

  if Is2000 then begin
    ck:=rkNetwork2K;
    dv:=rvNetworkNT;
  end else begin
    ck:=ClassKey;
    dv:=DescValue;
  end;
  GetClassDevices(ck,rvProtoClass,dv,FProto);
  GetClassDevices(ck,rvServClass,dv,FServ);
  GetClassDevices(ck,rvCliClass,dv,FCli);

  FMACAddress.Clear;
  L_Enum:=NbLanaEnum;
  if L_Enum.Length<>0 then
    for i:=0 to (L_Enum.Length-1) do begin
      RetCode:=NbReset(L_Enum.Lana[i]);
      if RetCode=NRC_GOODRET then begin
        ck:=NbGetMacAddr(i);
        if FMacAddress.IndexOf(ck)=-1 then
          FMacAddress.Add(ck);
      end;
    end;
end;

constructor TNetwork.Create;
begin
  inherited;
  FWinsock:=TWinsock.Create;
  FAdapter:=TStringList.Create;
  FIPAddress:=TStringList.Create;
  FMACAddress:=TStringList.Create;
  FProto:=TStringList.Create;
  FServ:=TStringList.Create;
  FCli:=TStringList.Create;
end;

destructor TNetwork.Destroy;
begin
  FWinsock.Free;
  FAdapter.Free;
  FMACAddress.Free;
  FIPAddress.Free;
  FProto.Free;
  FCli.Free;
  FServ.Free;
  inherited;
end;

procedure TNetwork.Report(var sl: TStringList);
begin
  with sl do begin
    add('Adapters:');
    addstrings(Adapter);
    add('');
    add('Protocols:');
    addstrings(Protocol);
    add('');
    add('Services:');
    addstrings(Service);
    add('');
    add('Clients:');
    addstrings(Client);
    add('');
    add('IP Addresses: '+IPAddress.CommaText);
    add('MAC Addresses: '+MACAddress.CommaText);
    Add('');
    Add(Format('%s (%d.%d): %s',[Winsock.Description,
                                 Hi(Winsock.MajorVersion),
                                 Lo(Winsock.MinorVersion),
                                 Winsock.Status]));
  end;
end;


{ TDisplay }

procedure TDisplay.GetInfo;
var
  rk :string;
  idata,bdata :pchar;
  sl :tstringlist;
  i :integer;
  DevMode : TDevMode;
  Found: Boolean;
const
  rkVideoHardware = {HKEY_LOCAL_MACHINE\}'HARDWARE\DEVICEMAP\VIDEO';
  rvVideoKey1 = '\Device\Video0';
  rvVideoKey2 = '\\Device\\Video0';
   rvHardware = 'HardwareInformation';
    rvHWVideo = 'AdapterString';
    rvHWDAC = 'DacType';
    rvHWChip = 'ChipType';
    rvHWMem = 'MemorySize';

  rvVideoClass = 'Display';

    rkClassInfo = 'INFO';
    rvCIVideo = 'DriverDesc';
    rvCIDAC = 'DACType';
    rvCIChip = 'ChipType';
    rvCIMem = 'VideoMemory';
    rvCIRev = 'Revision';

  rv3DClass = '3D Accelerators';

  rkBIOS = {HKEY_LOCAL_MACHINE\}'HARDWARE\DESCRIPTION\System';
    rvVideoBiosDate = 'VideoBiosDate';
    rvVideoBiosVersion = 'VideoBiosVersion';
begin
  FHorzRes:=GetDeviceCaps(GetDC(0),windows.HORZRES);
  FVertRes:=GetDeviceCaps(GetDC(0),windows.VERTRES);
  FColorDepth:=GetDeviceCaps(GetDC(0),BITSPIXEL);
  case GetDeviceCaps(GetDC(0),windows.TECHNOLOGY) of
    DT_PLOTTER:    FTechnology:='Vector Plotter';
    DT_RASDISPLAY: FTechnology:='Raster Display';
    DT_RASPRINTER: FTechnology:='Raster Printer';
    DT_RASCAMERA:  FTechnology:='Raster Camera';
    DT_CHARSTREAM: FTechnology:='Character Stream';
    DT_METAFILE:   FTechnology:='Metafile';
    DT_DISPFILE:   FTechnology:='Display File';
  end;
  FHorzSize:=GetDeviceCaps(GetDC(0),HORZSIZE);
  FVertSize:=GetDeviceCaps(GetDC(0),VERTSIZE);
  FPixelWidth:=GetDeviceCaps(GetDC(0),ASPECTX);
  FPixelHeight:=GetDeviceCaps(GetDC(0),ASPECTY);
  FPixelDiagonal:=GetDeviceCaps(GetDC(0),ASPECTXY);
  FCurveCaps:=[];
  if GetDeviceCaps(GetDC(0),windows.CURVECAPS)<>CC_NONE then begin
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_CIRCLES)=CC_CIRCLES then
      FCurveCaps:=FCurveCaps+[ccCircles];
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_PIE)=CC_PIE then
      FCurveCaps:=FCurveCaps+[ccPieWedges];
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_CHORD)=CC_CHORD then
      FCurveCaps:=FCurveCaps+[ccChords];
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_ELLIPSES)=CC_ELLIPSES then
      FCurveCaps:=FCurveCaps+[ccEllipses];
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_WIDE)=CC_WIDE then
      FCurveCaps:=FCurveCaps+[ccWideBorders];
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_STYLED)=CC_STYLED then
      FCurveCaps:=FCurveCaps+[ccStyledBorders];
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_WIDESTYLED)=CC_WIDESTYLED then
      FCurveCaps:=FCurveCaps+[ccWideStyledBorders];
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_INTERIORS)=CC_INTERIORS then
      FCurveCaps:=FCurveCaps+[ccInteriors];
    if (GetDeviceCaps(GetDC(0),windows.CURVECAPS) and CC_ROUNDRECT)=CC_ROUNDRECT then
      FCurveCaps:=FCurveCaps+[ccRoundedRects];
  end;
  FLineCaps:=[];
  if GetDeviceCaps(GetDC(0),windows.LINECAPS)<>LC_NONE then begin
    if (GetDeviceCaps(GetDC(0),windows.LINECAPS) and LC_POLYLINE)=LC_POLYLINE then
      FLineCaps:=FLineCaps+[lcPolylines];
    if (GetDeviceCaps(GetDC(0),windows.LINECAPS) and LC_MARKER)=LC_MARKER then
      FLineCaps:=FLineCaps+[lcMarkers];
    if (GetDeviceCaps(GetDC(0),windows.LINECAPS) and LC_POLYMARKER)=LC_POLYMARKER then
      FLineCaps:=FLineCaps+[lcMultipleMarkers];
    if (GetDeviceCaps(GetDC(0),windows.LINECAPS) and LC_WIDE)=LC_WIDE then
      FLineCaps:=FLineCaps+[lcWideLines];
    if (GetDeviceCaps(GetDC(0),windows.LINECAPS) and LC_STYLED)=LC_STYLED then
      FLineCaps:=FLineCaps+[lcStyledLines];
    if (GetDeviceCaps(GetDC(0),windows.LINECAPS) and LC_WIDESTYLED)=LC_WIDESTYLED then
      FLineCaps:=FLineCaps+[lcWideStyledLines];
    if (GetDeviceCaps(GetDC(0),windows.LINECAPS) and LC_INTERIORS)=LC_INTERIORS then
      FLineCaps:=FLineCaps+[lcInteriors];
  end;
  FPolygonCaps:=[];
  if GetDeviceCaps(GetDC(0),POLYGONALCAPS)<>PC_NONE then begin
    if (GetDeviceCaps(GetDC(0),POLYGONALCAPS) and PC_POLYGON)=PC_POLYGON then
      FPolygonCaps:=FPolygonCaps+[pcAltFillPolygons];
    if (GetDeviceCaps(GetDC(0),POLYGONALCAPS) and PC_RECTANGLE)=PC_RECTANGLE then
      FPolygonCaps:=FPolygonCaps+[pcRectangles];
    if (GetDeviceCaps(GetDC(0),POLYGONALCAPS) and PC_WINDPOLYGON)=PC_WINDPOLYGON then
      FPolygonCaps:=FPolygonCaps+[pcWindingFillPolygons];
    if (GetDeviceCaps(GetDC(0),POLYGONALCAPS) and PC_SCANLINE)=PC_SCANLINE then
      FPolygonCaps:=FPolygonCaps+[pcSingleScanlines];
    if (GetDeviceCaps(GetDC(0),POLYGONALCAPS) and PC_WIDE)=PC_WIDE then
      FPolygonCaps:=FPolygonCaps+[pcWideBorders];
    if (GetDeviceCaps(GetDC(0),POLYGONALCAPS) and PC_STYLED)=PC_STYLED then
      FPolygonCaps:=FPolygonCaps+[pcStyledBorders];
    if (GetDeviceCaps(GetDC(0),POLYGONALCAPS) and PC_WIDESTYLED)=PC_WIDESTYLED then
      FPolygonCaps:=FPolygonCaps+[pcWideStyledBorders];
    if (GetDeviceCaps(GetDC(0),POLYGONALCAPS) and PC_INTERIORS)=PC_INTERIORS then
      FPolygonCaps:=FPolygonCaps+[pcInteriors];
  end;
  FRasterCaps:=[];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_BANDING)=RC_BANDING then
    FRasterCaps:=FRasterCaps+[rcRequiresBanding];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_BITBLT)=RC_BITBLT then
    FRasterCaps:=FRasterCaps+[rcTranserBitmaps];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_BITMAP64)=RC_BITMAP64 then
    FRasterCaps:=FRasterCaps+[rcBitmaps64K];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_DI_BITMAP)=RC_DI_BITMAP then
    FRasterCaps:=FRasterCaps+[rcSetGetDIBits];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_DIBTODEV)=RC_DIBTODEV then
    FRasterCaps:=FRasterCaps+[rcSetDIBitsToDevice];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_FLOODFILL)=RC_FLOODFILL then
    FRasterCaps:=FRasterCaps+[rcFloodfills];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_GDI20_OUTPUT)=RC_GDI20_OUTPUT then
    FRasterCaps:=FRasterCaps+[rcWindows2xFeatures];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_PALETTE)=RC_PALETTE then
    FRasterCaps:=FRasterCaps+[rcPaletteBased];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_SCALING)=RC_SCALING then
    FRasterCaps:=FRasterCaps+[rcScaling];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_STRETCHBLT)=RC_STRETCHBLT then
    FRasterCaps:=FRasterCaps+[rcStretchBlt];
  if (GetDeviceCaps(GetDC(0),windows.RASTERCAPS) and RC_STRETCHDIB)=RC_STRETCHDIB then
    FRasterCaps:=FRasterCaps+[rcStretchDIBits];
  FTextCaps:=[];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_OP_CHARACTER)=TC_OP_CHARACTER then
    FTextCaps:=FTextCaps+[tcCharOutPrec];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_OP_STROKE)=TC_OP_STROKE then
    FTextCaps:=FTextCaps+[tcStrokeOutPrec];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_CP_STROKE)=TC_CP_STROKE then
    FTextCaps:=FTextCaps+[tcStrokeClipPrec];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_CR_90)=TC_CR_90 then
    FTextCaps:=FTextCaps+[tcCharRotation90];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_CR_ANY)=TC_CR_ANY then
    FTextCaps:=FTextCaps+[tcCharRotationAny];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_SF_X_YINDEP)=TC_SF_X_YINDEP then
    FTextCaps:=FTextCaps+[tcScaleIndependent];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_SA_DOUBLE)=TC_SA_DOUBLE then
    FTextCaps:=FTextCaps+[tcDoubledCharScaling];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_SA_INTEGER)=TC_SA_INTEGER then
    FTextCaps:=FTextCaps+[tcIntMultiScaling];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_SA_CONTIN)=TC_SA_CONTIN then
    FTextCaps:=FTextCaps+[tcAnyMultiExactScaling];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_EA_DOUBLE)=TC_EA_DOUBLE then
    FTextCaps:=FTextCaps+[tcDoubleWeightChars];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_IA_ABLE)=TC_IA_ABLE then
    FTextCaps:=FTextCaps+[tcItalics];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_UA_ABLE)=TC_UA_ABLE then
    FTextCaps:=FTextCaps+[tcUnderlines];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and  TC_SO_ABLE)=TC_SO_ABLE then
    FTextCaps:=FTextCaps+[tcStrikeouts];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_RA_ABLE)=TC_RA_ABLE then
    FTextCaps:=FTextCaps+[tcRasterFonts];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_VA_ABLE)=TC_VA_ABLE then
    FTextCaps:=FTextCaps+[tcVectorFonts];
  if (GetDeviceCaps(GetDC(0),windows.TEXTCAPS) and TC_SCROLLBLT)=TC_SCROLLBLT then
    FTextCaps:=FTextCaps+[tcNoScrollUsingBlts];
  sl:=tstringlist.create;
  FAdapter.Clear;
  FDAC.Clear;
  FChipset.Clear;
  FMemory.Clear;
  bdata:=stralloc(255);
  rk:=GetClassDevices(ClassKey,rvVideoClass,DescValue,FAdapter);
  Found:=False;
  with TRegistry.Create do begin
    RootKey:=HKEY_LOCAL_MACHINE;
    if OpenKey(rk,false) then begin
      GetKeyNames(sl);
      CloseKey;
      for i:=0 to sl.count-1 do
        if OpenKey(rk+'\'+sl[i]+'\'+rkClassInfo,false) then begin
          Found:=True;
          if ValueExists(rvCIDAC) then
            FDAC.Add(ReadString(rvCIDAC));
          if ValueExists(rvCIChip) then
            FChipset.Add(ReadString(rvCIChip));
          if ValueExists(rvCIRev) then
            FChipset[FChipset.Count-1]:=FChipset[FChipset.Count-1]+' Rev '+ReadString(rvCIRev);
          if ValueExists(rvCIMem) then
            FMemory.Add(inttostr(readinteger(rvCIMem)));
          CloseKey;
        end;
    end;
    if not Found then begin
      if OpenKey(rkVideoHardware,false) then begin
        if ValueExists(rvVideoKey1) then
          rk:=ReadString(rvVideoKey1)
        else
          if ValueExists(rvVideoKey2) then
            rk:=ReadString(rvVideoKey2)
          else
            rk:='';

        closekey;
        if rk<>'' then begin
          rk:=copy(rk,pos('Machine\',rk)+8,255);
          if OpenKey(rk,false) then begin
            if ValueExists(rvHardware+'.'+rvHWVideo) then
              try
                readbinarydata(rvHardware+'.'+rvHWVideo,bdata^,255);
                FAdapter.Add(getstrfrombuf(pchar(bdata)));
              except
              end;
            if ValueExists(rvHardware+'.'+rvHWDAC) then
              try
                readbinarydata(rvHardware+'.'+rvHWDAC,bdata^,255);
                FDAC.Add(getstrfrombuf(pchar(bdata)));
              except
              end;
            if ValueExists(rvHardware+'.'+rvHWChip) then
              try
                readbinarydata(rvHardware+'.'+rvHWChip,bdata^,255);
                FChipset.Add(getstrfrombuf(pchar(bdata)));
              except
              end;
            if ValueExists(rvHardware+'.'+rvHWMem) then
              try
                idata:=stralloc(255);
                readbinarydata(rvHardware+'.'+rvHWMem,idata,4);
                FMemory.Add(inttostr(integer(idata)));
                strdispose(idata);
              except
              end;
            closekey;
          end;
        end;
      end;
    end;
    if OpenKey(rkBIOS,false) then begin
      if ValueExists(rvVideoBIOSVersion) then begin
        try
          readbinarydata(rvVideoBIOSVersion,bdata^,151);
          FBIOSVersion:=strpas(pchar(bdata));
        except
        end;
      end;
      if ValueExists(rvVideoBIOSDate) then
        FBIOSDate:=ReadString(rvVideoBIOSDate);
      closekey;
    end;
    free;
  end;

  FAcc.Clear;
  GetClassDevices(ClassKey,rv3DClass,DescValue,FAcc);
  FModes.Clear;
  i:=0;
  while EnumDisplaySettings(nil,i,Devmode) do
    with Devmode do begin
      FModes.Add(Format('%d x %d - %d bit',[dmPelsWidth,dmPelsHeight,dmBitsPerPel]));
      Inc(i);
    end;
  strdispose(bdata);
  sl.free;
end;

procedure TDisplay.GetCurveCapsStr(AClear :boolean; ACaps: TStringList);
begin
  if AClear then
    ACaps.Clear;
  ACaps.Add('Circles: '+bool2yn(ccCircles in CurveCaps));
  ACaps.Add('Pie Wedges: '+bool2yn(ccPieWedges in CurveCaps));
  ACaps.Add('Chords: '+bool2yn(ccChords in CurveCaps));
  ACaps.Add('Ellipses: '+bool2yn(ccEllipses in CurveCaps));
  ACaps.Add('Wide Borders: '+bool2yn(ccWideBorders in CurveCaps));
  ACaps.Add('Styled Borders: '+bool2yn(ccStyledBorders in CurveCaps));
  ACaps.Add('Wide and Styled Borders: '+bool2yn(ccWideStyledBorders in CurveCaps));
  ACaps.Add('Interiors: '+bool2yn(ccInteriors in CurveCaps));
  ACaps.Add('Rounded Rectangles: '+bool2yn(ccRoundedRects in CurveCaps));
end;

procedure TDisplay.GetLineCapsStr(AClear :boolean; ACaps: TStringList);
begin
  if AClear then
    ACaps.Clear;
  ACaps.Add('Polylines: '+bool2yn(lcPolylines in LineCaps));
  ACaps.Add('Markers: '+bool2yn(lcMarkers in LineCaps));
  ACaps.Add('Multiple Markers: '+bool2yn(lcMultipleMarkers in LineCaps));
  ACaps.Add('Wide Lines: '+bool2yn(lcWideLines in LineCaps));
  ACaps.Add('Styled Lines: '+bool2yn(lcStyledLines in LineCaps));
  ACaps.Add('Wide and Styled Lines: '+bool2yn(lcWideStyledLines in LineCaps));
  ACaps.Add('Interiors: '+bool2yn(lcInteriors in LineCaps));
end;

procedure TDisplay.GetPolygonCapsStr(AClear :boolean; ACaps: TStringList);
begin
  if AClear then
    ACaps.Clear;
  ACaps.Add('Alternate Fill Polygons: '+bool2yn(pcAltFillPolygons in PolygonCaps));
  ACaps.Add('Rectangles: '+bool2yn(pcRectangles in PolygonCaps));
  ACaps.Add('Winding Fill Polygons: '+bool2yn(pcWindingFillPolygons in PolygonCaps));
  ACaps.Add('Single Scanlines: '+bool2yn(pcSingleScanlines in PolygonCaps));
  ACaps.Add('Wide Borders: '+bool2yn(pcWideBorders in PolygonCaps));
  ACaps.Add('Styled Borders: '+bool2yn(pcStyledBorders in PolygonCaps));
  ACaps.Add('Wide and Styled Borders: '+bool2yn(pcWideStyledBorders in PolygonCaps));
  ACaps.Add('Interiors: '+bool2yn(pcInteriors in PolygonCaps));
end;

procedure TDisplay.GetRasterCapsStr(AClear :boolean; ACaps: TStringList);
begin
  if AClear then
    ACaps.Clear;
  ACaps.Add('Requires Banding: '+bool2yn(rcRequiresBanding in RasterCaps));
  ACaps.Add('Can Transer Bitmaps: '+bool2yn(rcTranserBitmaps in RasterCaps));
  ACaps.Add('Supports Bitmaps > 64K: '+bool2yn(rcBitmaps64K in RasterCaps));
  ACaps.Add('Supports SetDIBits and GetDIBits: '+bool2yn(rcSetGetDIBits in RasterCaps));
  ACaps.Add('Supports SetDIBitsToDevice: '+bool2yn(rcSetDIBitsToDevice in RasterCaps));
  ACaps.Add('Can Perform Floodfills: '+bool2yn(rcFloodfills in RasterCaps));
  ACaps.Add('Supports Windows 2.0 Features: '+bool2yn(rcWindows2xFeatures in RasterCaps));
  ACaps.Add('Palette Based: '+bool2yn(rcPaletteBased in RasterCaps));
  ACaps.Add('Scaling: '+bool2yn(rcScaling in RasterCaps));
  ACaps.Add('Supports StretchBlt: '+bool2yn(rcStretchBlt in RasterCaps));
  ACaps.Add('Supports StretchDIBits: '+bool2yn(rcStretchDIBits in RasterCaps));
end;

procedure TDisplay.GetTextCapsStr(AClear :boolean; ACaps: TStringList);
begin
  if AClear then
    ACaps.Clear;
  ACaps.Add('Capable of Character Output Precision: '+bool2yn(tcCharOutPrec in TextCaps));
  ACaps.Add('Capable of Stroke Output Precision: '+bool2yn(tcStrokeOutPrec in TextCaps));
  ACaps.Add('Capable of Stroke Clip Precision: '+bool2yn(tcStrokeClipPrec in TextCaps));
  ACaps.Add('Supports 90 Degree Character Rotation: '+bool2yn(tcCharRotation90 in TextCaps));
  ACaps.Add('Supports Character Rotation to Any Angle: '+bool2yn(tcCharRotationAny in TextCaps));
  ACaps.Add('X And Y Scale Independent: '+bool2yn(tcScaleIndependent in TextCaps));
  ACaps.Add('Supports Doubled Character Scaling: '+bool2yn(tcDoubledCharScaling in TextCaps));
  ACaps.Add('Supports Integer Multiples Only When Scaling: '+bool2yn(tcIntMultiScaling in TextCaps));
  ACaps.Add('Supports Any Multiples For Exact Character Scaling: '+bool2yn(tcAnyMultiExactScaling in TextCaps));
  ACaps.Add('Supports Double Weight Characters: '+bool2yn(tcDoubleWeightChars in TextCaps));
  ACaps.Add('Supports Italics: '+bool2yn(tcItalics in TextCaps));
  ACaps.Add('Supports Underlines: '+bool2yn(tcUnderlines in TextCaps));
  ACaps.Add('Supports Strikeouts: '+bool2yn(tcStrikeouts in TextCaps));
  ACaps.Add('Supports Raster Fonts: '+bool2yn(tcRasterFonts in TextCaps));
  ACaps.Add('Supports Vector Fonts: '+bool2yn(tcVectorFonts in TextCaps));
  ACaps.Add('Cannot Scroll Using Blts: '+bool2yn(tcNoScrollUsingBlts in TextCaps));
end;

constructor TDisplay.Create;
begin
  inherited;
  FAdapter:=TStringList.Create;
  FModes:=TStringList.Create;
  FAcc:=TStringList.Create;
  FDAc:=TStringList.Create;
  FChipset:=TStringList.Create;
  FMemory:=TStringList.Create;
end;

destructor TDisplay.Destroy;
begin
  FAdapter.Free;
  FDAc.Free;
  FChipset.Free;
  FMemory.Free;
  FAcc.Free;
  FModes.Free;
  inherited;
end;

procedure TDisplay.Report(var sl: TStringList);
var
  i :integer;
begin
  with sl do begin
    for i:=0 to Adapter.count-1 do begin
       add(format('[%d] %s',[i+1,Adapter[i]]));
       if Chipset.count-1>=i then
         add('    Chipset: '+Chipset[i]);
        if DAC.count-1>=i then
          add('    DAC: '+DAC[i]);
        if Memory.count-1>=i then
          add('    Memory: '+Memory[i]+' B');
    end;
    add('');
    add(format('BIOS: %s (%s)',[BIOSVersion,BIOSDate]));
    add('Technology: '+Technology);
    add(format('Metrics: %d x %d - %d bit',[HorzRes,VertRes,ColorDepth]));
    add(format('Pixel Width: %d',[PixelWidth]));
    add(format('Pixel Height: %d',[PixelHeight]));
    add(format('Pixel Diagonal: %d',[PixelDiagonal]));
    add('');
    add('Available Video Modes:');
    AddStrings(Modes);
    add('');
    add('Curve Capabilities:');
    GetCurveCapsStr(false,sl);
    add('');
    add('Line Capabilities:');
    GetLineCapsStr(false,sl);
    add('');
    add('Polygonal Capabilities:');
    GetPolygonCapsStr(false,sl);
    add('');
    add('Raster Capabilities:');
    GetRasterCapsStr(false,sl);
    add('');
    add('Text Capabilities:');
    GetTextCapsStr(false,sl);
    add('#d Accelerators:');
    addstrings(Accelerator);
    add('');
  end;
end;

{ TMedia }

constructor TMedia.Create;
begin
  inherited;
  FDevice:=TStringList.Create;
end;

destructor TMedia.Destroy;
begin
  FDevice.Free;
  inherited;
end;

procedure TMedia.GetInfo;
var
  WOC :PWAVEOutCaps;
  WIC :PWAVEInCaps;
  MOC :PMIDIOutCaps;
  MIC :PMIDIInCaps;
  AXC :PAUXCaps;
  MXC :PMixerCaps;
const
  rv = 'DriverDesc';
  rvMediaClass = 'MEDIA';
begin
  FDevice.Clear;
  GetClassDevices(ClassKey,rvMediaClass,DescValue,FDevice);
  new(WOC);
  if WAVEOutGetDevCaps(0,WOC,SizeOf(TWAVEOutCaps))=MMSYSERR_NOERROR then
    FWAVEOut:=strpas(WOC^.szPname)+' v'+inttostr(hi(WOC^.vDriverVersion))+'.'+inttostr(hi(WOC^.vDriverVersion));
  dispose(WOC);
  new(WIC);
  if WAVEinGetDevCaps(0,WIC,SizeOf(TWAVEInCaps))=MMSYSERR_NOERROR then
    FWAVEIn:=strpas(WIC^.szPname)+' v'+inttostr(hi(WIC^.vDriverVersion))+'.'+inttostr(hi(WIC^.vDriverVersion));
  dispose(WIC);
  new(MOC);
  if MIDIoutGetDevCaps(0,MOC,SizeOf(TMIDIOutCaps))=MMSYSERR_NOERROR then
    FMIDIout:=strpas(MOC^.szPname)+' v'+inttostr(hi(MOC^.vDriverVersion))+'.'+inttostr(hi(MOC^.vDriverVersion));
  dispose(MOC);
  new(MIC);
  if MIDIinGetDevCaps(0,MIC,SizeOf(TMIDIInCaps))=MMSYSERR_NOERROR then
    FMIDIin:=strpas(MIC^.szPname)+' v'+inttostr(hi(MIC^.vDriverVersion))+'.'+inttostr(hi(MIC^.vDriverVersion));
  dispose(MIC);
  new(AXC);
  if AUXGetDevCaps(0,AXC,SizeOf(TAUXCaps))=MMSYSERR_NOERROR then
    FAUX:=strpas(AXC^.szPname)+' v'+inttostr(hi(AXC^.vDriverVersion))+'.'+inttostr(hi(AXC^.vDriverVersion));
  dispose(AXC);
  new(MXC);
  if MixerGetDevCaps(0,MXC,SizeOf(TMixerCaps))=MMSYSERR_NOERROR then
    FMixer:=strpas(MXC^.szPname)+' v'+inttostr(hi(MXC^.vDriverVersion))+'.'+inttostr(hi(MXC^.vDriverVersion));
  dispose(MXC);
end;

procedure TMedia.Report(var sl: TStringList);
begin
  with sl do begin
    add('Devices:');
    addstrings(Device);
    add('');
    add('Sound devices:');
    add(WaveIn);
    add(WaveOut);
    add(MIDIIn);
    add(MIDIOut);
    add(AUX);
    add(Mixer);
  end;
end;

{ TDevices }

constructor TDevices.Create;
begin
  inherited;
  FSD:=TStringList.Create;
  FUSB:=TStringList.Create;
  FPrinter:=TStringList.Create;
  FMonitor:=TStringList.Create;
  FPort:=TStringList.Create;
  FSCSI:=TStringList.Create;
  FModem:=TStringList.Create;
  FMouse:=TStringList.Create;
  FKeyboard:=TStringList.Create;
  FPCMCIA:=TStringList.Create;
  FInfrared:=TStringList.Create;
  FImage:=TStringList.Create;
end;

destructor TDevices.Destroy;
begin
  FSD.Free;
  FUSB.Free;
  FPrinter.Free;
  FMonitor.Free;
  FPort.Free;
  FModem.Free;
  FSCSI.Free;
  FMouse.Free;
  FKeyboard.Free;
  FPCMCIA.Free;
  FInfrared.Free;
  FImage.Free;
  inherited;
end;

procedure TDevices.GetInfo;
var
  i :integer;
const
  rvMonitorClass = 'Monitor';
  rvKeyboardClass = 'Keyboard';
  rvMouseClass = 'Mouse';
  rvSDClass = 'System';
  rvSCSIClass = 'SCSIAdapter';
  rvUSBClass = 'USB';
  rvModemClass = 'Modem';
  rvPortClass = 'Ports';
  rvPCMCIAClass = 'PCMCIA';
  rvInfraredClass = 'Infrared';
  rvImageClass = 'Image';
begin
  GetClassDevices(ClassKey,rvMonitorClass,DescValue,FMonitor);
  GetClassDevices(ClassKey,rvPortClass,DescValue,FPort);
  GetClassDevices(ClassKey,rvMouseClass,DescValue,FMouse);
  GetClassDevices(ClassKey,rvModemClass,DescValue,FModem);
  GetClassDevices(ClassKey,rvKeyboardClass,DescValue,FKeyboard);
  GetClassDevices(ClassKey,rvSCSIClass,DescValue,FSCSI);
  GetClassDevices(ClassKey,rvSDClass,DescValue,FSD);
  GetClassDevices(ClassKey,rvUSBClass,DescValue,FUSB);
  GetClassDevices(ClassKey,rvInfraredClass,DescValue,FInfrared);
  GetClassDevices(ClassKey,rvImageClass,DescValue,FImage);
  FPrinter.Clear;
  for i:=0 to Printers.Printer.Printers.count-1 do begin
    FPrinter.Add(Printers.printer.printers[i]);
    if i=Printers.printer.printerindex then
      FPrinter[i]:=FPrinter[i]+' (Default)';
  end;
end;

procedure TDevices.Report(var sl: TStringList);
begin
  with sl do begin
    add('Monitors:');
    addstrings(Monitor);
    add('');
    add('Keyboard:');
    addstrings(Keyboard);
    add('');
    add('Mouse:');
    addstrings(Mouse);
    add('');
    add('Printers:');
    addstrings(Printer);
    add('');
    add('Modems:');
    addstrings(Modem);
    add('');
    add('Ports:');
    addstrings(Port);
    add('');
    add('SCSI adapters:');
    addstrings(SCSI);
    add('');
    add('System devices:');
    addstrings(SystemDevice);
    add('');
    add('USB:');
    addstrings(USB);
    add('');
    add('PCMCIA:');
    addstrings(PCMCIA);
    add('');
    add('Infrared:');
    addstrings(Infrared);
    add('');
    add('Image devices:');
    addstrings(Image);
  end;
end;

{ TEngines }

procedure TEngines.GetInfo;
var
  s,s1 :string;
const
  rkBDESettings = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Borland\Database Engine';
    rvBDEDLLPath = 'DLLPATH';
    fnBDEDLL = 'IDAPI32.DLL';
  rkODBCSettings = {HKEY_LOCAL_MACHINE\}'SOFTWARE\ODBC\ODBCINST.INI\ODBC Core\FileList';
    rvODBCCoreDLL = 'ODBC32.DLL';
begin
  with TRegistry.Create do begin
    rootkey:=HKEY_LOCAL_MACHINE;
    if OpenKey(rkBDESettings,false) then begin
      if ValueExists(rvBDEDLLPath) then begin
        s:=ReadString(rvBDEDLLPath);
        FBDE:=readverinfo(s+'\'+fnBDEDLL,s1);
      end;
      closekey;
    end;
    if OpenKey(rkODBCSettings,false) then begin
      if ValueExists(rvODBCCoreDLL) then begin
        s:=ReadString(rvODBCCoreDLL);
        FODBC:=readverinfo(s,s1);
      end;
      closekey;
    end;
    free;
  end;
end;

procedure TEngines.Report(var sl: TStringList);
begin
  with sl do begin
    if ODBC<>'' then
      add('Open Database Connectivity '+ODBC)
    else
      add('Open Database Connectivity not found');
    if BDE<>'' then
      add('Borland Database Engine '+BDE)
    else
      add('Borland Database Engine not found');
  end;
end;

{ TAPM }

procedure TAPM.GetInfo;
var
  PS :_System_Power_Status;
  OK: Boolean;
begin
  FACPowerStatus:='Unknown';
  FBatteryChargeStatus:='Unknown';
  FBatteryLifePercent:=0;
  FBatteryLifeTime:=0;
  FBatteryLifeFullTime:=0;
  ok:=GetSystemPowerStatus(PS);
  if OK then begin
    case PS.ACLineStatus Of
      0 : FACPowerStatus:='OffLine';
      1 : FACPowerStatus:='OnLine';
      else FACPowerStatus:='Unknown';
    end;
    if (PS.BatteryFlag or 1)=1 then
      FBatteryChargeStatus := 'High'
    else
      if (PS.BatteryFlag or 2)=2 then
        FBatteryChargeStatus:='Low'
      else
        if (PS.BatteryFlag or 4)=4 then
          FBatteryChargeStatus:='Critical'
        else
          if (PS.BatteryFlag or 8)=8 then
            FBatteryChargeStatus:='Charging'
          else
            if (PS.BatteryFlag or 128)=128 then
              FBatteryChargeStatus:='No Battery'
            else
              FBatteryChargeStatus:='Unknown';
    FBatteryLifePercent:=PS.BatteryLifePercent;
    FBatteryLifeTime:=PS.BatteryLifeTime;
    FBatteryLifeFullTime:=PS.BatteryFullLifeTime;
  end;
end;

procedure TAPM.Report(var sl: TStringList);
begin
  with sl do begin
    add('AC Power Status: '+ACPowerStatus);
    add('Battrey Charge Status: '+BatteryChargeStatus);
    if BatteryLifePercent<=100 then begin
      add('Battrey Life Full Time: '+formatseconds(BatteryLifeFullTime,true,false,false));
      add('Battery Life Time: '+formatseconds(BatteryLifeTime,true,false,false));
    end;
  end;
end;

{ TDirectX }

constructor TDirectX.Create;
begin
  inherited;
  FDirect3D:=TStringlist.Create;
  FDirectPlay:=TStringlist.Create;
  FDirectMusic:=TStringlist.Create;
end;

destructor TDirectX.Destroy;
begin
  FDirect3D.Free;
  FDirectPlay.Free;
  FDirectMusic.Free;
  inherited;
end;

procedure TDirectX.GetInfo;
var
  bdata :pchar;
  sl :tstringlist;
  i :integer;
const
  rkDirectX = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\DirectX';
    rvDXVersionNT = 'InstalledVersion';
    rvDXVersion95 = 'Version';
  rkDirect3D = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\Direct3D\Drivers';
  rkDirectPlay = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\DirectPlay\Services';
  rkDirectMusic = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\DirectMusic\SoftwareSynths';
    rvDesc = 'Description';
begin
  with TRegistry.Create do begin
    rootkey:=HKEY_LOCAL_MACHINE;
    if OpenKey(rkDirectX,false) then begin
      bdata:=stralloc(255);
      if ValueExists(rvDXVersion95) then
        FVersion:=ReadString(rvDXVersion95);
      if FVersion='' then
        if ValueExists(rvDXVersionNT) then
          try
            readbinarydata(rvDXVersionNT,bdata^,4);
            FVersion:=inttostr(lo(integer(bdata^)))+'.'+inttostr(hi(integer(bdata^)));
          except
            {$IFDEF D4PLUS}
            try
              readbinarydata(rvDXVersionNT,bdata^,8);
              FVersion:=inttostr(lo(integer(bdata^)))+'.'+inttostr(hi(integer(bdata^)));
            except
            end;
            {$ENDIF}
          end;
      closekey;
      strdispose(bdata);
    end;
    FDirect3D.Clear;
    FDirectPlay.Clear;
    FDirectMusic.Clear;
    sl:=tstringlist.create;
    if OpenKey(rkDirect3D,false) then begin
      getkeynames(sl);
      closekey;
      for i:=0 to sl.count-1 do
        if OpenKey(rkDirect3D+'\'+sl[i],false) then begin
          if ValueExists(rvDesc) then
            FDirect3D.Add(ReadString(rvDesc));
          closekey;
        end;
    end;
    if OpenKey(rkDirectPlay,false) then begin
      getkeynames(sl);
      closekey;
      for i:=0 to sl.count-1 do
        if OpenKey(rkDirectPlay+'\'+sl[i],false) then begin
          if ValueExists(rvDesc) then
            FDirectPlay.Add(ReadString(rvDesc));
          closekey;
        end;
    end;
    if OpenKey(rkDirectMusic,false) then begin
      getkeynames(sl);
      closekey;
      for i:=0 to sl.count-1 do
        if OpenKey(rkDirectMusic+'\'+sl[i],false) then begin
          if ValueExists(rvDesc) then
            FDirectMusic.Add(ReadString(rvDesc));
          closekey;
        end;
    end;
    sl.free;
    free;
  end;
end;


procedure TDirectX.Report(var sl: TStringList);
begin
  with sl do begin
    if Version<>'' then begin
      add('Installed version: '+Version);
      add('');
      add('Direct3D:');
      addstrings(Direct3D);
      add('');
      add('DirectPlay:');
      addstrings(DirectPlay);
      add('');
      add('DirectMusic:');
      addstrings(DirectMusic);
    end else
      add('Not installed.');
  end;   
end;

{ TMSystemInfo }

constructor TMSystemInfo.Create(AOwner: TComponent);
begin
  inherited;
  FAbout:=cAbout;
  FCPU:=TCPU.Create;
  FMemory:=TMemory.Create;
  FOS:=TOperatingSystem.Create;
  FDisk:=TDisk.Create;
  FWorkstation:=TWorkstation.Create;
  FNetwork:=TNetwork.Create;
  FDisplay:=TDisplay.Create;
  FMedia:=TMedia.Create;
  FDevices:=TDevices.Create;
  FEngines:=TEngines.Create;
  FAPM:=TAPM.Create;
  FDirectX:=TDirectX.Create;
  Refresh;
end;

destructor TMSystemInfo.Destroy;
begin
  FCPU.Free;
  FMemory.Free;
  FOS.Free;
  FDisk.Free;
  FWorkstation.Free;
  FNetwork.Free;
  FDisplay.Free;
  FMedia.Free;
  FDevices.Free;
  FEngines.Free;
  FAPM.Free;
  FDirectX.Free;
  inherited;
end;

procedure TMSystemInfo.Refresh;
begin
  CPU.GetInfo;
  Memory.GetInfo;
  OS.GetInfo;
  Disk.GetInfo;
  Disk.Drive:=copy(OS.Directories.Values['Windows'],1,2);
  FWorkstation.GetInfo;
  FNetwork.GetInfo;
  FDisplay.GetInfo;
  FMedia.GetInfo;
  FDevices.GetInfo;
  FEngines.GetInfo;
  FAPM.GetInfo;
  FDirectX.GetInfo;
end;

procedure TMSystemInfo.Report(var sl: TStringList);
begin
  sl.add(About);
  sl.add('');
  sl.add('Workstation');
  sl.add('-----------');
  Workstation.Report(sl);
  sl.add('');
  sl.add('Operating System');
  sl.add('----------------');
  OS.Report(sl);
  sl.add('');
  sl.add('CPU');
  sl.add('---');
  CPU.Report(sl);
  sl.add('');
  sl.add('Memory');
  sl.add('------');
  Memory.Report(sl);
  sl.add('');
  sl.add('Display');
  sl.add('-------');
  Display.Report(sl);
  sl.add('');
  sl.add('Advanced Power Management');
  sl.add('-------------------------');
  APM.Report(sl);
  sl.add('');
  sl.add('Media');
  sl.add('-----');
  Media.Report(sl);
  sl.add('');
  sl.add('Network');
  sl.add('-------');
  Network.Report(sl);
  sl.add('');
  sl.add('Devices');
  sl.add('-------');
  Devices.Report(sl);
  sl.add('');
  sl.add('Engines');
  sl.add('-------');
  Engines.Report(sl);
  sl.add('');
  sl.add('DirectX');
  sl.add('-------');
  DirectX.Report(sl);
  sl.add('');
  sl.add('Drives');
  sl.add('------');
  Disk.Report(sl);
end;

procedure TMSystemInfo.SetAbout(const Value: string);
begin
end;

{ TMemory }

function TMemory.GetGDIRes: Byte;
begin
  {$IFDEF ONLYWIN9X}
  Result:=GetFreeSysRes(cGDI)
  {$ELSE}
  Result:=0;
  {$ENDIF}
end;

function TMemory.GetSystemRes: Byte;
begin
  {$IFDEF ONLYWIN9X}
  Result:=GetFreeSysRes(cSystem)
  {$ELSE}
  Result:=0;
  {$ENDIF}
end;

function TMemory.GetUSERRes: Byte;
begin
  {$IFDEF ONLYWIN9X}
  Result:=GetFreeSysRes(cUser)
  {$ELSE}
  Result:=0;
  {$ENDIF}
end;

procedure TMemory.GetInfo;
var
  SI :TSystemInfo;
  MS :TMemoryStatus;
begin
  ZeroMemory(@MS,SizeOf(MS));
  MS.dwLength:=SizeOf(MS);
  GlobalMemoryStatus(MS);
  MemoryLoad:=MS.dwMemoryLoad;
  PhysicalTotal:=MS.dwTotalPhys;
  PhysicalFree:=MS.dwAvailPhys;
  VirtualTotal:=MS.dwTotalVirtual;
  VirtualFree:=MS.dwAvailVirtual;
  PageFileTotal:=MS.dwTotalPageFile;
  PageFileFree:=MS.dwAvailPageFile;
  ZeroMemory(@SI,SizeOf(SI));
  GetSystemInfo(SI);
  AllocGranularity:=SI.dwAllocationGranularity;
  MaxAppAddress:=DWORD(SI.lpMaximumApplicationAddress);
  MinAppAddress:=DWORD(SI.lpMinimumApplicationAddress);
  PageSize:=DWORD(SI.dwPageSize);
  FSystemRes:=GetSystemRes;
  FGDIRes:=GetGDIRes;
  FUserRes:=GetUserRes;
end;

procedure TMemory.Report(var sl: TStringList);
begin
  with sl do begin
    add(formatfloat('Physical Memory Total: #,## B',PhysicalTotal));
    add(formatfloat('Physical Memory Free: #,## B',PhysicalFree));
    add(formatfloat('Page File Total: #,## B',PageFileTotal));
    add(formatfloat('Page File Free: #,## B',PageFileFree));
    add(formatfloat('Virtual Memory Total: #,## B',VirtualTotal));
    add(formatfloat('Virtual Memory Free: #,## B',VirtualFree));
    add('');
    add(formatfloat('Allocation Granularity: #,## B',AllocGranularity));
    add(format('Application Addres Range: %s - %s',[inttohex(MinAppAddress,8),inttohex(MaxAppAddress,8)]));
    add(formatfloat('Page Size: #,## B',PageSize));
  end;
end;


{ TTimeZone }

type
  TRegTimeZoneInfo = packed record
    Bias: Longint;
    StandardBias: Longint;
    DaylightBias: Longint;
    StandardDate: TSystemTime;
    DaylightDate: TSystemTime;
  end;

function IsLeapYear(Year: Word): Boolean;
begin
  Result:=((Year and 3)=0) and ((Year mod 100>0) or (Year mod 400=0));
end;

function DaysInMonth(const DT: TDateTime): Byte;
var
  y,m,d: Word;
begin
  DecodeDate(DT,y,m,d);
  case m of
    2: if IsLeapYear(y) then
         Result:=29
       else
         Result:=28;
    4, 6, 9, 11: Result:=30;
    else
      Result := 31;
  end;
end;

function DayOfMonth2Date(year,month,weekInMonth,dayInWeek: word): TDateTime;
var
  days: integer;
  day : integer;
begin
  if (weekInMonth>=1) and (weekInMonth<=4) then begin
    day:=DayOfWeek(EncodeDate(year,month,1));
    day:=1+dayInWeek-day;
    if day<=0 then
      Inc(day,7);
    day:=day+7*(weekInMonth-1);
    Result:=EncodeDate(year,month,day);
  end else
    if weekInMonth=5 then begin
      days:=DaysInMonth(EncodeDate(year,month,1));
      day:=DayOfWeek(EncodeDate(year,month,days));
      day:=days+(dayInWeek-day);
      if day>days then
        Dec(day,7);
      Result:=EncodeDate(year,month,day);
    end else
      Result:=0;
end;

function DSTDate2Date(dstDate: TSystemTime; year: word): TDateTime;
begin
  if dstDate.wMonth=0 then
    Result:=0
  else
    if dstDate.wYear=0 then
      Result:=DayOfMonth2Date(year,dstDate.wMonth,dstDate.wDay,dstDate.wDayOfWeek+1)+
              EncodeTime(dstDate.wHour,dstDate.wMinute,dstDate.wSecond,dstDate.wMilliseconds)
    else
      Result:=SystemTimeToDateTime(dstDate);
end;

function GetTZDaylightSavingInfoForYear(
    TZ: TTimeZoneInformation; year: word;
    var DaylightDate, StandardDate: TDateTime;
    var DaylightBias, StandardBias: longint): boolean;
begin
  Result:=false;
  try
    if (TZ.DaylightDate.wMonth <> 0) and
       (TZ.StandardDate.wMonth <> 0) then begin
      DaylightDate:=DSTDate2Date(TZ.DaylightDate,year);
      StandardDate:=DSTDate2Date(TZ.StandardDate,year);
      DaylightBias:=TZ.Bias+TZ.DaylightBias;
      StandardBias:=TZ.Bias+TZ.StandardBias;
      Result:=true;
    end;
  except
  end;
end;

function CompareSysTime(st1, st2: TSystemTime): integer;
begin
  if st1.wYear<st2.wYear then
    Result:=-1
  else
    if st1.wYear>st2.wYear then
      Result:=1
    else
      if st1.wMonth<st2.wMonth then
        Result:=-1
      else
        if st1.wMonth>st2.wMonth then
          Result:=1
        else
          if st1.wDayOfWeek<st2.wDayOfWeek then
            Result:=-1
          else
            if st1.wDayOfWeek>st2.wDayOfWeek then
              Result:=1
            else
              if st1.wDay<st2.wDay then
                Result:=-1
              else
                if st1.wDay>st2.wDay then
                  Result:=1
                else
                  if st1.wHour<st2.wHour then
                    Result:=-1
                  else
                    if st1.wHour>st2.wHour then
                      Result:=1
                    else
                      if st1.wMinute<st2.wMinute then
                        Result:=-1
                      else
                        if st1.wMinute>st2.wMinute then
                          Result:=1
                         else
                           if st1.wSecond<st2.wSecond then
                             Result:=-1
                           else
                             if st1.wSecond>st2.wSecond then
                               Result:=1
                             else
                               if st1.wMilliseconds<st2.wMilliseconds then
                                 Result:=-1
                               else
                                 if st1.wMilliseconds>st2.wMilliseconds then
                                   Result:=1
                                 else
                                   Result:=0;
end;

function IsEqualTZ(tz1, tz2: TTimeZoneInformation): boolean;
begin
  Result:=(tz1.Bias=tz2.Bias) and
          (tz1.StandardBias=tz2.StandardBias) and
          (tz1.DaylightBias=tz2.DaylightBias) and
          (CompareSysTime(tz1.StandardDate,tz2.StandardDate)=0) and
          (CompareSysTime(tz1.DaylightDate,tz2.DaylightDate)=0) and
          (WideCharToString(tz1.StandardName)=WideCharToString(tz2.StandardName)) and
          (WideCharToString(tz1.DaylightName)=WideCharToString(tz2.DaylightName));
end;

procedure TTimeZone.GetInfo;
var
  TZKey: string;
  RTZ: TRegTimeZoneInfo;
  HomeTZ, RegTZ: TTimeZoneInformation;
  y,m,d,i: Word;
  sl: TStringList;
const
  rkNTTimeZones = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\Windows NT\CurrentVersion\Time Zones';
  rk9xTimeZones = {HKEY_LOCAL_MACHINE\}'SOFTWARE\Microsoft\Windows\CurrentVersion\Time Zones';
  rkTimeZone = {HKEY_LOCAL_MACHINE\}'SYSTEM\CurrentControlSet\Control\TimeZoneInformation';
  rvTimeZone = 'StandardName';
begin
  GetTimeZoneInformation(HomeTZ);
  sl:=TStringList.Create;
  with TRegistry.create do begin
    rootkey:=HKEY_LOCAL_MACHINE;
    if IsNT then
      TZKey:=rkNTTimeZones
    else
      TZKey:=rk9xTimeZones;
    if OpenKey(TZKey,False) then begin
      GetKeyNames(sl);
      CloseKey;
      for i:=0 to sl.Count-1 do
        if OpenKey(TZKey+'\'+sl[i],False) then begin
          if GetDataSize('TZI')=SizeOf(RTZ) then begin
            ReadBinaryData('TZI',RTZ,SizeOf(RTZ));
            StringToWideChar(ReadString('Std'),@RegTZ.StandardName,SizeOf(RegTZ.StandardName) div SizeOf(WideChar));
            StringToWideChar(ReadString('Dlt'),@RegTZ.DaylightName,SizeOf(RegTZ.DaylightName) div SizeOf(WideChar));
            RegTZ.Bias:=RTZ.Bias;
            RegTZ.StandardBias:=RTZ.StandardBias;
            RegTZ.DaylightBias:=RTZ.DaylightBias;
            RegTZ.StandardDate:=RTZ.StandardDate;
            RegTZ.DaylightDate:=RTZ.DaylightDate;
            if IsEqualTZ(HomeTZ,RegTZ) then begin
              FDisp:=ReadString('Display');
              try
                FMap:=ReadString('MapID');
              except
                FMap:='';
              end;
              Break;
            end;
          end;
          CloseKey;
        end;
    end;
    Free;
  end;
  FBias:=HomeTZ.Bias;
  FStd:=HomeTZ.StandardName;
  FDay:=HomeTZ.DaylightName;
  DecodeDate(Date,y,m,d);
  GetTZDaylightSavingInfoForYear(HomeTZ,y,FDayStart,FStdStart,FDayBias,FStdBias);
  sl.Free;
end;

procedure TTimeZone.Report(var sl: TStringList);
begin
  with sl do begin
    Add('Time Zone: '+DisplayName);
    Add(StandardName+': '+DateTimeToStr(StandardStart));
    Add('Standard Bias: '+IntToStr(StandardBias)+' min.');
    Add(DaylightName+': '+DateTimeToStr(DaylightStart));
    Add('Daylight Bias: '+IntToStr(DaylightBias)+' min.');
  end;
end;

initialization
  IsNT:=IsOSNT;
  IS95:=IsOS95;
  Is98:=IsOS98;
  Is2000:=IsOS2000;
  IsOSR2:=IsOSOSR2;
  WindowsUser:=GetUser;
  MachineName:=GetMachine;
  Platform:=GetPlatform;
  if IsNT then
    ClassKey:='SYSTEM\CurrentControlSet\Control\Class'
  else
    ClassKey:='SYSTEM\CurrentControlSet\Services\Class';
end.

